#!/usr/bin/php
<?php
require_once('initialize.php');
require_once('core/ProjectPeer.php');

$cvs = getProjects('/cvsroot');
$svn = getProjects('/svnroot');

foreach ($cvs as $project) {
	echo 'Selecting SVN SCM for project: ' . $project->getProjectName() . "\n";
	$project->disablePlugin('scmsvn');
	$project->enablePlugin('scmcvs');
}

foreach ($svn as $project) {
	echo 'Selecting CVS SCM for project: ' . $project->getProjectName() . "\n";
	$project->disablePlugin('scmcvs');
	$project->enablePlugin('scmsvn');
}

function getProjects($path) {
	$projects = array();
	$dir = @opendir($path);
	if ($dir !== false) {
		while (($project = @readdir($dir)) !== false) {
			if (is_dir($path.'/'.$project) && $project != '.' && $project != '..') {
				$prjObj = ProjectPeer::retrieveByUnixName(trim($project));
				if ($prjObj && is_object($prjObj)) {
					echo 'Found project: ' . $project . "\n";
					$projects[] = $prjObj;
				}
		    }
		}
	}
	return $projects;
}

?>
