--
-- PostgreSQL database dump
--

SET client_encoding = 'UNICODE';
SET check_function_bodies = false;

SET search_path = public, pg_catalog;

--
-- Data for TOC entry 40 (OID 36712)
-- Name: filesystem; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY filesystem (filesystem_id, section, ref_id, file_name, file_name_safe, file_type, file_size, deleted) FROM stdin;
\.


--
-- Data for TOC entry 41 (OID 36721)
-- Name: deleted_project; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY deleted_project (unix_group_name, delete_date, isdeleted) FROM stdin;
b	2005-12-16 21:08:26.684898-03	0
\.


--
-- Data for TOC entry 42 (OID 36729)
-- Name: project; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY project (project_id, project_name, unix_name, homepage_url, is_public, status, description, register_purpose, register_license_other, create_date, template_project_id) FROM stdin;
1	First test project	default	\N	t	1	\N	\N		2005-12-08 13:06:13.395971-03	1
2	Testing project	testing_project		t	0	This is the first testing project	I want to register this project in order to test the registration process.		2005-12-16 19:52:32-03	1
\.


--
-- Data for TOC entry 43 (OID 36742)
-- Name: country_code; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY country_code (country_name, ccode) FROM stdin;
Argentina	ar
United States	us
\.


--
-- Data for TOC entry 44 (OID 36748)
-- Name: theme; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY theme (theme_id, dirname, fullname) FROM stdin;
1	gforge5	GForge 5 default theme
\.


--
-- Data for TOC entry 45 (OID 36758)
-- Name: language; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY "language" (language_id, name, filename, language_code) FROM stdin;
1	English	Base.tab	en   
\.


--
-- Data for TOC entry 46 (OID 36768)
-- Name: user; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY "user" (user_id, unix_name, email, status, password_md5, password_crypt, create_date, confirm_hash, email_new, timezone, date_format, address, address2, phone, fax, title, firstname, lastname, ccode, language_id, theme_id) FROM stdin;
9	mottalli	marcelo@localhost.localdomain	0	a7cdd863b96fdb2be81a9d2753f8181e	$1$rvCJVljw$cwHK66j24WopVN2nuRyUH0	2005-12-20 13:55:38-03	\N	\N	tz	df	ma	aa	ph	fax	Mr.	Marcelo	Mottalli	us	1	1
\.


--
-- Data for TOC entry 47 (OID 36794)
-- Name: site_admin; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY site_admin (user_id) FROM stdin;
\.


--
-- Data for TOC entry 48 (OID 36800)
-- Name: monitor; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY monitor (project_id, section, ref_id, user_id) FROM stdin;
\.


--
-- Data for TOC entry 49 (OID 36813)
-- Name: audit_trail; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY audit_trail (change_date, user_id, section, ref_id, field_name, new_value, old_value) FROM stdin;
\.


--
-- Data for TOC entry 50 (OID 36827)
-- Name: unix_shell; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY unix_shell (unix_shell_id, shell_name, "path") FROM stdin;
1	Bash	/bin/bash
2	Restricted CVS Shell	/bin/cvssh.pl
\.


--
-- Data for TOC entry 51 (OID 36837)
-- Name: user_unix; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY user_unix (user_id, unix_shell_id, unix_uid, unix_gid, unix_box, authorized_keys) FROM stdin;
\.


--
-- Data for TOC entry 52 (OID 36857)
-- Name: scm_server; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY scm_server (scm_server_id, scm_type, hostname) FROM stdin;
1	CVS	cvs.
2	SVN	svn.
\.


--
-- Data for TOC entry 53 (OID 36867)
-- Name: project_scm; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY project_scm (project_id, enable_anonread, scm_server_id, controlled, hostname, root_directory) FROM stdin;
\.


--
-- Data for TOC entry 54 (OID 36886)
-- Name: forum; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY forum (forum_id, project_id, forum_name, is_public, description, send_all_posts_to, thread_count, message_count, most_recent_date, datatype) FROM stdin;
1	1	First forum	t	This is the first forum. Should work.	\N	0	0	2005-12-13 12:59:31.423064-03	1
\.


--
-- Data for TOC entry 55 (OID 36907)
-- Name: forum_thread; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY forum_thread (forum_thread_id, forum_id, created_by, thread_name, message_count, most_recent_date) FROM stdin;
\.


--
-- Data for TOC entry 56 (OID 36930)
-- Name: forum_message; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY forum_message (forum_message_id, forum_thread_id, created_by, subject, body, post_date) FROM stdin;
\.


--
-- Data for TOC entry 57 (OID 36955)
-- Name: frs_package; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY frs_package (frs_package_id, project_id, package_name, status_id, is_public) FROM stdin;
\.


--
-- Data for TOC entry 58 (OID 36972)
-- Name: frs_release; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY frs_release (frs_release_id, frs_package_id, release_name, release_notes, changes, status_id, preformatted, release_date, released_by) FROM stdin;
\.


--
-- Data for TOC entry 59 (OID 36994)
-- Name: frs_filetype; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY frs_filetype (frs_filetype_id, filetype_name) FROM stdin;
\.


--
-- Data for TOC entry 60 (OID 37004)
-- Name: frs_processor; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY frs_processor (frs_processor_id, processor_name) FROM stdin;
\.


--
-- Data for TOC entry 61 (OID 37014)
-- Name: frs_file; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY frs_file (frs_file_id, file_name, frs_release_id, frs_filetype_id, frs_processor_id, file_size, post_date, download_count) FROM stdin;
\.


--
-- Data for TOC entry 62 (OID 37039)
-- Name: frs_dlstats_file; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY frs_dlstats_file (ip_address, frs_file_id, download_date, user_id) FROM stdin;
\.


--
-- Data for TOC entry 63 (OID 37051)
-- Name: deleted_mailing_list; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY deleted_mailing_list (mailing_list_name, delete_date, isdeleted) FROM stdin;
\.


--
-- Data for TOC entry 64 (OID 37059)
-- Name: mailman; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY mailman (mailman_id, project_id, list_name, is_public, list_password, list_admin_id, status_id, description, create_date) FROM stdin;
\.


--
-- Data for TOC entry 65 (OID 37082)
-- Name: news; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY news (news_id, project_id, submitted_by, is_approved, post_date, forum_id, summary, details) FROM stdin;
\.


--
-- Data for TOC entry 66 (OID 37101)
-- Name: news_count; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY news_count (project_id, total) FROM stdin;
\.


--
-- Data for TOC entry 67 (OID 37112)
-- Name: user_session; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY user_session (user_id, session_hash, ip_addr, login_time) FROM stdin;
\.


--
-- Data for TOC entry 68 (OID 37125)
-- Name: snippet; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY snippet (snippet_id, created_by, name, description, snippet_type) FROM stdin;
\.


--
-- Data for TOC entry 69 (OID 37140)
-- Name: snippet_package; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY snippet_package (snippet_package_id, created_by, name, description) FROM stdin;
\.


--
-- Data for TOC entry 70 (OID 37154)
-- Name: snippet_package_version; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY snippet_package_version (snippet_package_version_id, snippet_package_id, changes, snippet_version, submitted_by, post_date) FROM stdin;
\.


--
-- Data for TOC entry 71 (OID 37185)
-- Name: survey_question; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY survey_question (question_id, project_id, question, question_type) FROM stdin;
\.


--
-- Data for TOC entry 72 (OID 37201)
-- Name: survey; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY survey (survey_id, project_id, survey_title, survey_questions, is_active) FROM stdin;
\.


--
-- Data for TOC entry 73 (OID 37217)
-- Name: survey_response; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY survey_response (user_id, survey_id, question_id, response, post_date) FROM stdin;
\.


--
-- Data for TOC entry 74 (OID 37235)
-- Name: trove_cat; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY trove_cat (trove_cat_id, parent_trove_cat_id, shortname, fullname, description) FROM stdin;
\.


--
-- Data for TOC entry 75 (OID 37249)
-- Name: trove_snippet; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY trove_snippet (trove_cat_id, snippet_id, snippet_count) FROM stdin;
\.


--
-- Data for TOC entry 76 (OID 37263)
-- Name: trove_snippet_package; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY trove_snippet_package (trove_cat_id, snippet_package_id, snippet_package_count) FROM stdin;
\.


--
-- Data for TOC entry 77 (OID 37277)
-- Name: trove_project; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY trove_project (trove_cat_id, project_id) FROM stdin;
\.


--
-- Data for TOC entry 78 (OID 37290)
-- Name: trove_project_count; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY trove_project_count (trove_cat_id, total) FROM stdin;
\.


--
-- Data for TOC entry 79 (OID 37303)
-- Name: role; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY role (role_id, project_id, role_name) FROM stdin;
\.


--
-- Data for TOC entry 80 (OID 37316)
-- Name: role_setting; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY role_setting (role_id, section, ref_id, value) FROM stdin;
\.


--
-- Data for TOC entry 81 (OID 37324)
-- Name: user_project; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY user_project (user_id, project_id, role_id, join_date) FROM stdin;
\.


--
-- Data for TOC entry 82 (OID 37342)
-- Name: user_preferences; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY user_preferences (user_id, preference_name, set_date, preference_value) FROM stdin;
\.


--
-- Data for TOC entry 83 (OID 37356)
-- Name: tracker; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker (tracker_id, project_id, tracker_name, description, is_public, email_all_updates, email_address, due_period, submit_instructions, browse_instructions, datatype, item_total, open_count) FROM stdin;
\.


--
-- Data for TOC entry 84 (OID 37377)
-- Name: tracker_item; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_item (tracker_item_id, tracker_id, status_id, priority, submitted_by, open_date, close_date, summary, details, last_modified_date, sort_order, parent_id) FROM stdin;
\.


--
-- Data for TOC entry 85 (OID 37406)
-- Name: tracker_time_code; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_time_code (tracker_time_code_id, time_name) FROM stdin;
\.


--
-- Data for TOC entry 86 (OID 37416)
-- Name: tracker_item_time; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_item_time (tracker_item_time_id, date_entry, user_id, tracker_item_id, hours, tracker_time_code_id) FROM stdin;
\.


--
-- Data for TOC entry 87 (OID 37434)
-- Name: tracker_item_relation; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_item_relation (tracker_item_id, related_tracker_item_id, link_type) FROM stdin;
\.


--
-- Data for TOC entry 88 (OID 37448)
-- Name: tracker_item_assignee; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_item_assignee (tracker_item_id, assignee, percent_utilization) FROM stdin;
\.


--
-- Data for TOC entry 89 (OID 37464)
-- Name: tracker_item_message; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_item_message (tracker_item_message_id, tracker_item_id, submitted_by, adddate, body) FROM stdin;
\.


--
-- Data for TOC entry 90 (OID 37484)
-- Name: tracker_canned_response; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_canned_response (tracker_canned_response_id, tracker_id, title, body) FROM stdin;
\.


--
-- Data for TOC entry 91 (OID 37501)
-- Name: notification_queue; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY notification_queue (notification_queue_id, section, ref_id, user_id, subject, body, queue_date, send_date) FROM stdin;
\.


--
-- Data for TOC entry 92 (OID 37515)
-- Name: scm_user_stats; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY scm_user_stats (stat_date, project_id, user_id, checkouts, commits, adds) FROM stdin;
\.


--
-- Data for TOC entry 93 (OID 37530)
-- Name: scm_project_stats; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY scm_project_stats (stat_date, project_id, checkouts, commits, adds) FROM stdin;
\.


--
-- Data for TOC entry 94 (OID 37541)
-- Name: activity_log; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY activity_log (activity_date, project_id, page, activity_type) FROM stdin;
\.



--
-- Data for TOC entry 97 (OID 37571)
-- Name: user_plugin; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY user_plugin (user_id, plugin_id, plugin_order) FROM stdin;
\.


--
-- Data for TOC entry 98 (OID 37583)
-- Name: cron_history; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY cron_history (rundate, job, output) FROM stdin;
\.


--
-- Data for TOC entry 99 (OID 37591)
-- Name: tracker_extra_field; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_extra_field (tracker_extra_field_id, tracker_id, field_name, field_type, attribute1, attribute2, is_required, alias, field_order, use_in_quick_browse) FROM stdin;
\.


--
-- Data for TOC entry 100 (OID 37612)
-- Name: tracker_extra_field_element; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_extra_field_element (element_id, tracker_extra_field_id, element_name, status_id, default_selected, sort_order) FROM stdin;
\.


--
-- Data for TOC entry 101 (OID 37630)
-- Name: tracker_extra_field_data; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_extra_field_data (tracker_extra_field_data_id, tracker_item_id, field_data, tracker_extra_field_id) FROM stdin;
\.


--
-- Data for TOC entry 102 (OID 37647)
-- Name: project_join_request; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY project_join_request (project_id, user_id, comments, request_date) FROM stdin;
\.


--
-- Data for TOC entry 103 (OID 37665)
-- Name: scm_module; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY scm_module (scm_module_id, project_id, "path") FROM stdin;
\.


--
-- Data for TOC entry 104 (OID 37677)
-- Name: scm_preference; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY scm_preference (project_id, require_tracker_item_id) FROM stdin;
\.


--
-- Data for TOC entry 105 (OID 37688)
-- Name: scm_trackeritem_commit; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY scm_trackeritem_commit (scm_trackeritem_commit_id, tracker_item_id, commit_date, message_log, user_id) FROM stdin;
\.


--
-- Data for TOC entry 106 (OID 37707)
-- Name: scm_trackeritem_commit_file; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY scm_trackeritem_commit_file (scm_trackeritem_commit_id, modified_file, prev_version, current_version) FROM stdin;
\.


--
-- Data for TOC entry 107 (OID 37723)
-- Name: tracker_query; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_query (tracker_query_id, tracker_id, user_id, query_name, is_selected) FROM stdin;
\.


--
-- Data for TOC entry 108 (OID 37741)
-- Name: tracker_query_field; Type: TABLE DATA; Schema: public; Owner: gforge
--

COPY tracker_query_field (tracker_query_id, query_field_type, query_field_id, query_field_values) FROM stdin;
\.


--
-- TOC entry 2 (OID 36710)
-- Name: filesystem_filesystem_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('filesystem_filesystem_id_seq', 1, false);


--
-- TOC entry 3 (OID 36727)
-- Name: project_project_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('project_project_id_seq', 4, true);


--
-- TOC entry 4 (OID 36746)
-- Name: theme_theme_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('theme_theme_id_seq', 3, true);


--
-- TOC entry 5 (OID 36756)
-- Name: language_language_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('language_language_id_seq', 1, true);


--
-- TOC entry 6 (OID 36766)
-- Name: user_user_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('user_user_id_seq', 10, true);


--
-- TOC entry 7 (OID 36825)
-- Name: unix_shell_unix_shell_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('unix_shell_unix_shell_id_seq', 2, true);


--
-- TOC entry 8 (OID 36855)
-- Name: scm_server_scm_server_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('scm_server_scm_server_id_seq', 2, true);


--
-- TOC entry 9 (OID 36884)
-- Name: forum_forum_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('forum_forum_id_seq', 1, true);


--
-- TOC entry 10 (OID 36905)
-- Name: forum_thread_forum_thread_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('forum_thread_forum_thread_id_seq', 1, false);


--
-- TOC entry 11 (OID 36928)
-- Name: forum_message_forum_message_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('forum_message_forum_message_id_seq', 1, false);


--
-- TOC entry 12 (OID 36953)
-- Name: frs_package_frs_package_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('frs_package_frs_package_id_seq', 1, false);


--
-- TOC entry 13 (OID 36970)
-- Name: frs_release_frs_release_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('frs_release_frs_release_id_seq', 1, false);


--
-- TOC entry 14 (OID 36992)
-- Name: frs_filetype_frs_filetype_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('frs_filetype_frs_filetype_id_seq', 1, false);


--
-- TOC entry 15 (OID 37002)
-- Name: frs_processor_frs_processor_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('frs_processor_frs_processor_id_seq', 1, false);


--
-- TOC entry 16 (OID 37012)
-- Name: frs_file_frs_file_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('frs_file_frs_file_id_seq', 1, false);


--
-- TOC entry 17 (OID 37057)
-- Name: mailman_mailman_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('mailman_mailman_id_seq', 1, false);


--
-- TOC entry 18 (OID 37080)
-- Name: news_news_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('news_news_id_seq', 1, false);


--
-- TOC entry 19 (OID 37123)
-- Name: snippet_snippet_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('snippet_snippet_id_seq', 1, false);


--
-- TOC entry 20 (OID 37138)
-- Name: snippet_package_snippet_package_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('snippet_package_snippet_package_id_seq', 1, false);


--
-- TOC entry 21 (OID 37152)
-- Name: snippet_package_version_snippet_package_version_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('snippet_package_version_snippet_package_version_id_seq', 1, false);


--
-- TOC entry 22 (OID 37183)
-- Name: survey_question_question_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('survey_question_question_id_seq', 1, false);


--
-- TOC entry 23 (OID 37199)
-- Name: survey_survey_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('survey_survey_id_seq', 1, false);


--
-- TOC entry 24 (OID 37233)
-- Name: trove_cat_trove_cat_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('trove_cat_trove_cat_id_seq', 1, false);


--
-- TOC entry 25 (OID 37301)
-- Name: role_role_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('role_role_id_seq', 1, false);


--
-- TOC entry 26 (OID 37354)
-- Name: tracker_tracker_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_tracker_id_seq', 1, false);


--
-- TOC entry 27 (OID 37375)
-- Name: tracker_item_tracker_item_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_item_tracker_item_id_seq', 1, false);


--
-- TOC entry 28 (OID 37404)
-- Name: tracker_time_code_tracker_time_code_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_time_code_tracker_time_code_id_seq', 1, false);


--
-- TOC entry 29 (OID 37414)
-- Name: tracker_item_time_tracker_item_time_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_item_time_tracker_item_time_id_seq', 1, false);


--
-- TOC entry 30 (OID 37462)
-- Name: tracker_item_message_tracker_item_message_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_item_message_tracker_item_message_id_seq', 1, false);


--
-- TOC entry 31 (OID 37482)
-- Name: tracker_canned_response_tracker_canned_response_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_canned_response_tracker_canned_response_id_seq', 1, false);


--
-- TOC entry 32 (OID 37499)
-- Name: notification_queue_notification_queue_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('notification_queue_notification_queue_id_seq', 1, false);


--
-- TOC entry 33 (OID 37549)
-- Name: plugin_plugin_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('plugin_plugin_id_seq', 4, true);


--
-- TOC entry 34 (OID 37589)
-- Name: tracker_extra_field_tracker_extra_field_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_extra_field_tracker_extra_field_id_seq', 1, false);


--
-- TOC entry 35 (OID 37610)
-- Name: tracker_extra_field_element_element_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_extra_field_element_element_id_seq', 1, false);


--
-- TOC entry 36 (OID 37628)
-- Name: tracker_extra_field_data_tracker_extra_field_data_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_extra_field_data_tracker_extra_field_data_id_seq', 1, false);


--
-- TOC entry 37 (OID 37663)
-- Name: scm_module_scm_module_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('scm_module_scm_module_id_seq', 1, false);


--
-- TOC entry 38 (OID 37686)
-- Name: scm_trackeritem_commit_scm_trackeritem_commit_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('scm_trackeritem_commit_scm_trackeritem_commit_id_seq', 1, false);


--
-- TOC entry 39 (OID 37721)
-- Name: tracker_query_tracker_query_id_seq; Type: SEQUENCE SET; Schema: public; Owner: gforge
--

SELECT pg_catalog.setval('tracker_query_tracker_query_id_seq', 1, false);
