<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/docman/lib/DocmanFile.php';
// (on-demand) include_once 'plugins/docman/lib/DocmanFilePeer.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'plugins/docman/lib/DocmanFileVersionPeer.php';

/**
 * Base class that represents a row from the 'docman_file_version' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to DocmanFileVersion class. 
 * 
 * @package plugins.docman.lib 
 */
abstract class BaseDocmanFileVersion extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var DocmanFileVersionPeer
	 */
	protected static $peer;

	/**
	 * The value for the docman_file_version_id field.
	 * @var int	  
	 */
	protected $docman_file_version_id;	

	/**
	 * The value for the docman_file_id field.
	 * @var int	  
	 */
	protected $docman_file_id;	

	/**
	 * The value for the create_date field.
	 * @var int	  
	 */
	protected $create_date = -1;	

	/**
	 * The value for the changes field.
	 * @var string	  
	 */
	protected $changes;	

	/**
	 * The value for the version_number field.
	 * @var double	  
	 */
	protected $version_number;	

	/**
	 * The value for the created_by field.
	 * @var int	  
	 */
	protected $created_by;	

	/**
	 * The value for the is_approved field.
	 * @var boolean	  
	 */
	protected $is_approved = false;	
  
	/**
	 * Get the DocmanFileVersionId column value.
	 *  
	 * @return int	  
	 */
	public function getDocmanFileVersionId()
	{
		return $this->docman_file_version_id;
	}


	/**
	 * Set the value of `docman_file_version_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setDocmanFileVersionId($v)
	{
		if ($this->docman_file_version_id !== $v) {
			$this->docman_file_version_id = $v;
			$this->modifiedColumns[] = DocmanFileVersionPeer::DOCMAN_FILE_VERSION_ID;
		}
				
	}

  
	/**
	 * Get the DocmanFileId column value.
	 *  
	 * @return int	  
	 */
	public function getDocmanFileId()
	{
		return $this->docman_file_id;
	}


	/**
	 * Set the value of `docman_file_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setDocmanFileId($v)
	{
		if ($this->docman_file_id !== $v) {
			$this->docman_file_id = $v;
			$this->modifiedColumns[] = DocmanFileVersionPeer::DOCMAN_FILE_ID;
		}
			
		if ($this->aDocmanFile !== null && $this->aDocmanFile->getDocmanFileId() !== $v) {
			$this->aDocmanFile = null;
		}
			
	}


	/**
	 * Get the [optionally formatted] `create_date` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreateDate($format = 'Y-m-d H:i:s')
	{
		if ($this->create_date === null || $this->create_date === '') {
			return null;
		} elseif (!is_int($this->create_date)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->create_date);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of create_date as date/time value: " . var_export($this->create_date, true));
			}
		} else {
			$ts = $this->create_date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `create_date` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCreateDate($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for create_date from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->create_date !== $ts || $ts === -1) {
			$this->create_date = $ts;
			$this->modifiedColumns[] = DocmanFileVersionPeer::CREATE_DATE;
		}
		
	}

  
	/**
	 * Get the Changes column value.
	 *  
	 * @return string	  
	 */
	public function getChanges()
	{
		return $this->changes;
	}


	/**
	 * Set the value of `changes` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setChanges($v)
	{
		if ($this->changes !== $v) {
			$this->changes = $v;
			$this->modifiedColumns[] = DocmanFileVersionPeer::CHANGES;
		}
				
	}

  
	/**
	 * Get the VersionNumber column value.
	 *  
	 * @return double	  
	 */
	public function getVersionNumber()
	{
		return $this->version_number;
	}


	/**
	 * Set the value of `version_number` column.	  
	 *  
	 * @param double $v new value
	 * @return void
	 *  
	 */
	public function setVersionNumber($v)
	{
		if ($this->version_number !== $v) {
			$this->version_number = $v;
			$this->modifiedColumns[] = DocmanFileVersionPeer::VERSION_NUMBER;
		}
				
	}

  
	/**
	 * Get the CreatedBy column value.
	 *  
	 * @return int	  
	 */
	public function getCreatedBy()
	{
		return $this->created_by;
	}


	/**
	 * Set the value of `created_by` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setCreatedBy($v)
	{
		if ($this->created_by !== $v) {
			$this->created_by = $v;
			$this->modifiedColumns[] = DocmanFileVersionPeer::CREATED_BY;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the IsApproved column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsApproved()
	{
		return $this->is_approved;
	}


	/**
	 * Set the value of `is_approved` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsApproved($v)
	{
		if ($this->is_approved !== $v || $v === false) {
			$this->is_approved = $v;
			$this->modifiedColumns[] = DocmanFileVersionPeer::IS_APPROVED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->docman_file_version_id = $rs->getInt($startcol + 0);					
			$this->docman_file_id = $rs->getInt($startcol + 1);					
			$this->create_date = $rs->getTimestamp($startcol + 2, null);
			$this->changes = $rs->getString($startcol + 3);					
			$this->version_number = $rs->getFloat($startcol + 4);					
			$this->created_by = $rs->getInt($startcol + 5);					
			$this->is_approved = $rs->getBoolean($startcol + 6);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating DocmanFileVersion object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(DocmanFileVersionPeer::DATABASE_NAME);
		$criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_VERSION_ID, $this->docman_file_version_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(DocmanFileVersionPeer::DATABASE_NAME);
		if ($this->isColumnModified(DocmanFileVersionPeer::DOCMAN_FILE_VERSION_ID)) $criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_VERSION_ID, $this->docman_file_version_id);
		if ($this->isColumnModified(DocmanFileVersionPeer::DOCMAN_FILE_ID)) $criteria->add(DocmanFileVersionPeer::DOCMAN_FILE_ID, $this->docman_file_id);
		if ($this->isColumnModified(DocmanFileVersionPeer::CREATE_DATE)) $criteria->add(DocmanFileVersionPeer::CREATE_DATE, $this->create_date);
		if ($this->isColumnModified(DocmanFileVersionPeer::CHANGES)) $criteria->add(DocmanFileVersionPeer::CHANGES, $this->changes);
		if ($this->isColumnModified(DocmanFileVersionPeer::VERSION_NUMBER)) $criteria->add(DocmanFileVersionPeer::VERSION_NUMBER, $this->version_number);
		if ($this->isColumnModified(DocmanFileVersionPeer::CREATED_BY)) $criteria->add(DocmanFileVersionPeer::CREATED_BY, $this->created_by);
		if ($this->isColumnModified(DocmanFileVersionPeer::IS_APPROVED)) $criteria->add(DocmanFileVersionPeer::IS_APPROVED, $this->is_approved);
		return $criteria;			
	}
	
	

	/**
	 * @var DocmanFile	  
	 */
	protected $aDocmanFile;

	/**
	 * Declares an association between this object and a DocmanFile object
	 *
	 * @param DocmanFile $v
	 * @return void
	 * @throws PropelException
	 */
	public function setDocmanFile($v)
	{
			
		if ($v === null) {
			$this->setDocmanFileId(NULL);
		} else {
			$this->setDocmanFileId($v->getDocmanFileId());
		}
   
		$this->aDocmanFile = $v;
	}


	/**
	 * Get the associated DocmanFile object
	 *
	 * @param Connection Optional Connection object.
	 * @return DocmanFile The associated DocmanFile object.
	 * @throws PropelException
	 */
	public function getDocmanFile($con = null)
	{
		// include the Peer class
		include_once 'plugins/docman/lib/DocmanFilePeer.php';

		if ($this->aDocmanFile === null && ($this->docman_file_id !== null)) {
	
			$this->aDocmanFile = DocmanFilePeer::retrieveByPK($this->docman_file_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = DocmanFilePeer::retrieveByPK($this->docman_file_id, $con);
			   $obj->addDocmanFileVersions($this);
			 */
		}
		return $this->aDocmanFile;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setDocmanFileKey($key)
	{

		$this->setDocmanFileId( (int) $key);			
		
	}

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setCreatedBy(NULL);
		} else {
			$this->setCreatedBy($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->created_by !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->created_by, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->created_by, $con);
			   $obj->addDocmanFileVersions($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setCreatedBy( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("docman_file_version_id", "docman_file_id", "create_date", "changes", "version_number", "created_by", "is_approved", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case DocmanFileVersionPeer::DOCMAN_FILE_VERSION_ID:
				return $this->getDocmanFileVersionId();
				break;
		  
			case DocmanFileVersionPeer::DOCMAN_FILE_ID:
				return $this->getDocmanFileId();
				break;
		  
			case DocmanFileVersionPeer::CREATE_DATE:
				return $this->getCreateDate();
				break;
		  
			case DocmanFileVersionPeer::CHANGES:
				return $this->getChanges();
				break;
		  
			case DocmanFileVersionPeer::VERSION_NUMBER:
				return $this->getVersionNumber();
				break;
		  
			case DocmanFileVersionPeer::CREATED_BY:
				return $this->getCreatedBy();
				break;
		  
			case DocmanFileVersionPeer::IS_APPROVED:
				return $this->getIsApproved();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getDocmanFileVersionId();
				break;
  
			case 1:
				return $this->getDocmanFileId();
				break;
  
			case 2:
				return $this->getCreateDate();
				break;
  
			case 3:
				return $this->getChanges();
				break;
  
			case 4:
				return $this->getVersionNumber();
				break;
  
			case 5:
				return $this->getCreatedBy();
				break;
  
			case 6:
				return $this->getIsApproved();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(DocmanFileVersionPeer::DOCMAN_FILE_VERSION_ID, $arr)) $this->setDocmanFileVersionId($arr[DocmanFileVersionPeer::DOCMAN_FILE_VERSION_ID]);
  
		if (array_key_exists(DocmanFileVersionPeer::DOCMAN_FILE_ID, $arr)) $this->setDocmanFileId($arr[DocmanFileVersionPeer::DOCMAN_FILE_ID]);
  
		if (array_key_exists(DocmanFileVersionPeer::CREATE_DATE, $arr)) $this->setCreateDate($arr[DocmanFileVersionPeer::CREATE_DATE]);
  
		if (array_key_exists(DocmanFileVersionPeer::CHANGES, $arr)) $this->setChanges($arr[DocmanFileVersionPeer::CHANGES]);
  
		if (array_key_exists(DocmanFileVersionPeer::VERSION_NUMBER, $arr)) $this->setVersionNumber($arr[DocmanFileVersionPeer::VERSION_NUMBER]);
  
		if (array_key_exists(DocmanFileVersionPeer::CREATED_BY, $arr)) $this->setCreatedBy($arr[DocmanFileVersionPeer::CREATED_BY]);
  
		if (array_key_exists(DocmanFileVersionPeer::IS_APPROVED, $arr)) $this->setIsApproved($arr[DocmanFileVersionPeer::IS_APPROVED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case DocmanFileVersionPeer::DOCMAN_FILE_VERSION_ID:
				$this->setDocmanFileVersionId($value);
				break;
	  
			case DocmanFileVersionPeer::DOCMAN_FILE_ID:
				$this->setDocmanFileId($value);
				break;
	  
			case DocmanFileVersionPeer::CREATE_DATE:
				$this->setCreateDate($value);
				break;
	  
			case DocmanFileVersionPeer::CHANGES:
				$this->setChanges($value);
				break;
	  
			case DocmanFileVersionPeer::VERSION_NUMBER:
				$this->setVersionNumber($value);
				break;
	  
			case DocmanFileVersionPeer::CREATED_BY:
				$this->setCreatedBy($value);
				break;
	  
			case DocmanFileVersionPeer::IS_APPROVED:
				$this->setIsApproved($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setDocmanFileVersionId($value);
				break;
  
			case 1:
				$this->setDocmanFileId($value);
				break;
  
			case 2:
				$this->setCreateDate($value);
				break;
  
			case 3:
				$this->setChanges($value);
				break;
  
			case 4:
				$this->setVersionNumber($value);
				break;
  
			case 5:
				$this->setCreatedBy($value);
				break;
  
			case 6:
				$this->setIsApproved($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(DocmanFileVersionPeer::DATABASE_NAME);

		try {
			$con->begin();
			DocmanFileVersionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(DocmanFileVersionPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aDocmanFile !== null) {
				if ($this->aDocmanFile->isModified()) $this->aDocmanFile->save($con);
				$this->setDocmanFile($this->aDocmanFile);
			}
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = DocmanFileVersionPeer::doInsert($this, $con);
					$this->setDocmanFileVersionId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					DocmanFileVersionPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return DocmanFileVersionPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aDocmanFile !== null) {
				if (($retval = $this->aDocmanFile->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = DocmanFileVersionPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed docman_file_version_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setDocmanFileVersionId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getDocmanFileVersionId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return DocmanFileVersion Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new DocmanFileVersion();
		$copyObj->setDocmanFileId($this->docman_file_id);
		$copyObj->setCreateDate($this->create_date);
		$copyObj->setChanges($this->changes);
		$copyObj->setVersionNumber($this->version_number);
		$copyObj->setCreatedBy($this->created_by);
		$copyObj->setIsApproved($this->is_approved);
		
		$copyObj->setNew(true);
		
		$copyObj->setDocmanFileVersionId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return DocmanFileVersionPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new DocmanFileVersionPeer();
		}
		return self::$peer;
	}

}
