<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for DocmanFolder
//
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('plugins/docman/lib/DocmanFolderPeer.php');
require_once('plugins/docman/lib/DocmanFolder.php');
require_once('GFUrl.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/docman/lib/html/DocmanAdminTemplate.php');
$theme = new DocmanAdminTemplate();

$project = GFUrl::getUrl()->getProject();
if (isset($_REQUEST['parent_folder_id']) && $_REQUEST['parent_folder_id'] > 0) {
	$DocmanFolder = DocmanFolderPeer::retrieveByPk($_REQUEST['parent_folder_id']);
	if (!is_object($DocmanFolder) 
		|| $DocmanFolder->getProject()->getProjectId() != $project->getProjectId() 
		|| !$DocmanFolder->userCanCreate()) {
		throw new PermissionDeniedException();
	}
}

$params = array(
		'project' => $project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('DocmanFolder.AddNewPageTitle')
		);

$folder_name=((isset($_POST['folder_name'])) ? htmlspecialchars($_POST['folder_name']) : '' );
$is_public=((isset($_POST['is_public'])) ? htmlspecialchars($_POST['is_public']) : '' );
$parent_folder_id=$_REQUEST['parent_folder_id'];

include('forms/DocmanFolderAdd-tpl.php');

?>
