<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2006-02-27
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('external/fckeditor/fckeditor.php');
require_once('plugins/docman/lib/InfoParser.php');
require_once('lib/core/Filesystem.php');
require_once('lib/core/FilesystemPeer.php');
require_once('lib/html/HTMLWidget.php');

$theme->header($params);

$latestfile=$df->getLatestVersion()->getFile();
$file_id = $latestfile->getFilesystemId();
$file_name = $latestfile->getFilename();
$file_type = $latestfile->getFileType();

if ((!isset($addversionoption)) || ($addversionoption == "")) {
	$addversionoption = DocmanFile::EDITED_UPLOAD;
}

//Based on the file type, enables/disables inline editing feature
if ($df->getLatestVersion()->getFile()->getFileType()== 'text/html') {
	$inline_editable = true;
	$oFCKeditor = new FCKeditor('message',$latestfile->getFileData());
	$oFCKeditor->BasePath = GFUrl::getUrl()->buildURL('/fckeditor/');
	$oFCKeditor->Width = "700";
	$oFCKeditor->Height = "500";
	$oFCKeditor->ToolbarSet = "GForge";
	$project = GFUrl::getUrl()->getProject();
	$oFCKeditor->setConnectorURLs($project->getProjectId());
} else {
	$inline_editable = false;
	$addversionoption = DocmanFile::EDITED_UPLOAD;
}


function setAddVersionOption($addversionoption,$mode,$element) {

	if ($addversionoption == $mode) {
		switch ($element) {
			case 'radio': $res = "SELECTED";
			break;

			case 'style': $res = 'style="display:block;"';
			break;
		}
	} else {
		switch ($element) {
			case 'radio': $res = "";
			break;

			case 'style': $res = 'style="display:none;"';
			break;			
		}
	}
	return($res);
}
?>
<script type="text/javascript">

var addversionoption=<?php echo $addversionoption; ?>;

function show_hide(addversionoption) {

	if (addversionoption == '<?php echo DocmanFile::EDITED_INLINE; ?>') {
		document.getElementById("inline").style.display = 'none';
		document.getElementById("inline").style.display = '';		
		document.getElementById("upload").style.display = '';
		document.getElementById("upload").style.display = 'none';
	} else {
		document.getElementById("upload").style.display = 'none';
		document.getElementById("upload").style.display = '';
		document.getElementById("inline").style.display = '';
		document.getElementById("inline").style.display = 'none';
	}

	return(addversionoption);
}

</script>
<?php if ($inline_editable) { ?>
<table>
  <tr>
    <td><p>
      <label>
        <input name="action_type" <?php echo setAddVersionOption($addversionoption,DocmanFile::EDITED_UPLOAD,'radio'); ?> type="radio" id="action_type_0" value="1" checked="checked" onclick="javascript:addversionoption=show_hide('<?php echo DocmanFile::EDITED_UPLOAD; ?>');" />Upload a File</label>
      <br />
      <label>
				<input type="radio" <?php echo setAddVersionOption($addversionoption,DocmanFile::EDITED_INLINE,'radio'); ?> name="action_type" value="2" id="action_type_1" onclick="javascript:addversionoption=show_hide('<?php echo DocmanFile::EDITED_INLINE ?>');" />Add file with inline editor</label>
      <br />
    </p></td>
  </tr>	
</table>
<?php
}
 ?>
<div id="upload" <?php echo setAddVersionOption($addversionoption,DocmanFile::EDITED_UPLOAD,'style'); ?>>
<form enctype="multipart/form-data" id="docversionadd1" name="docversionadd2" method="POST" action="<?php echo GFUrl::getUrl()->currentBaseURL('DocmanFileVersionAddAction'); ?>&redirect_to=<?php echo $redirect_to; ?>">
<input type="hidden" name="id" value="<?php echo $id; ?>">
<table>	
	<tr>
		<td><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;[#<?php echo $id ;?>] <?php echo $df->getLatestVersion()->getFile()->getFileName(); ?></td>
	</tr>
	<tr>
		<td><strong><?php echo Language::getSessText('Docman.UploadNew'); ?>:</strong><br />
		<input type="file" name="doc"></td>
	</tr>
	<tr>
		<td><strong><?php echo Language::getSessText('Docman.ChangesName'); ?>:</strong><br />
		<textarea rows="4" cols="40" name="changes"></textarea></td>
	</tr>
	<tr>
		<td>
			<?php echo HTMLWidget::button("submit", "Upload", "submit"); ?>
			<?php echo HTMLWidget::button("button",  $Lang->getText('Common.Cancel') ,"cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'','docman',$redirect_to,array('action' => 'DocmanFileEdit', 'id' => $id)) . "'; ")?>
		</td>
	</tr>
</table>
</form>
</div>
<?php if ($inline_editable) { ?>
<div id="inline" <?php echo setAddVersionOption($addversionoption,DocmanFile::EDITED_INLINE,'style'); ?>>
<form enctype="multipart/form-data" id="docversionadd2" name="docversionadd2" method="POST" action="<?php echo GFUrl::getUrl()->currentBaseURL('DocmanFileVersionAddAction'); ?>&redirect_to=<?php echo $redirect_to; ?>&addversionoption=<?php echo DocmanFile::EDITED_INLINE; ?>">
<input type="hidden" name="id" value="<?php echo $id; ?>">
<input type="hidden" name="file_name" value="<?php echo $file_name; ?>">
<input type="hidden" name="action_type" value="<?php echo DocmanFile::EDITED_INLINE; ?>">
<table>
	<tr>
		<td><img src="/images/docman_doc.gif" height="16" width="16" border="0">&nbsp;[#<?php echo $id ;?>] <?php echo $df->getLatestVersion()->getFile()->getFileName(); ?></td>
	</tr>
	<tr>
		<td><strong><?php echo Language::getSessText('Docman.ChangesName'); ?>:</strong><br />
		<textarea rows="4" cols="40" name="changes"></textarea></td>
	</tr>
	<tr>
		<td><strong>File contents:&nbsp;*</strong><br />		
		<?php echo $oFCKeditor->CreateHtml(); ?>
		</td>
	</tr>		
	<tr>
		<td>
			<?php echo HTMLWidget::button("submit", "Upload", "submit");?>
			<?php echo HTMLWidget::button("button","" .   $Lang->getText('Common.Cancel') . " ","cancel","","window.location = '" .   GFUrl::getUrl()->projectURL(GFUrl::getUrl()->getProject(),'','docman',$redirect_to,array('action' => 'DocmanFileEdit', 'id' => $id)) . "'; ")?>
		</td>
	</tr>
</table>
</form>
</div>
<?php

} //end inline editing

$theme->footer($params);
?>
