<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing FrsRelease
//
require_once('plugins/frs/lib/FrsReleasePeer.php');
require_once('plugins/frs/lib/FrsRelease.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('lib/core/Filesystem.php');
require_once('lib/core/TroveLinkPeer.php');
require_once('html/HTMLWidget.php');
require_once('lib/html/TagsRenderer.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/frs/lib/html/FrsAdminTemplate.php');
$theme = new FrsAdminTemplate();

$Project = GFUrl::getUrl()->getProject();
$FrsRelease = FrsReleasePeer::retrieveByPk($_REQUEST['frs_release_id']);
$FrsPackage = $FrsRelease->getFrsPackage();
if (!is_object($FrsPackage) || !$FrsPackage->userCanUpdate() 
	|| $FrsPackage->getProject()->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}
$obj = $FrsRelease;

$params = array(
		'project' => $Project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('FrsRelease.EditPageTitle'),
		'frspackage' => $FrsPackage,
		'frsrelease' => $FrsRelease
		);

//$frs_package_id = ( (isset($_POST) && isset($_POST['frs_package_id'])) ? htmlspecialchars($_POST['frs_package_id']) : $obj->getFrsPackageId() );
$release_name = ( (isset($_POST) && isset($_POST['release_name'])) ? htmlspecialchars($_POST['release_name']) : $obj->getReleaseName() );
$release_notes = ( (isset($_POST) && isset($_POST['release_notes'])) ? htmlspecialchars($_POST['release_notes']) : $obj->getReleaseNotes() );
$changes = ( (isset($_POST) && isset($_POST['changes'])) ? htmlspecialchars($_POST['changes']) : $obj->getChanges() );
$status_id = ( (isset($_POST) && isset($_POST['status_id'])) ? htmlspecialchars($_POST['status_id']) : $obj->getStatusId() );
$preformatted = ( (isset($_POST) && isset($_POST['preformatted'])) ? htmlspecialchars($_POST['preformatted']) : $obj->getPreformatted() );
$release_date = ( (isset($_POST) && isset($_POST['release_date'])) ? htmlspecialchars($_POST['release_date']) : $obj->getReleaseDate('M d Y') );
$is_released = ( (isset($_POST) && isset($_POST['is_released'])) ? htmlspecialchars($_POST['is_released']) : $obj->getIsReleased() );

//get selected trove
$c = new Criteria();
$c->add(TroveLinkPeer::SECTION, FrsRelease::SECTION);
$c->add(TroveLinkPeer::REF_ID, $_REQUEST['frs_release_id']);
$trove = TroveLinkPeer::doSelectOne($c);
if (is_object($trove)) {
	$selectTrove = $trove->getTroveCategoryId();
} else {
	$selectTrove = 100;
}

include ('forms/FrsReleaseEdit-tpl.php');

?>
