<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'mailman' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.mailman.lib.map
 */
class MailmanMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.mailman.lib.map.MailmanMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("mailman");
		$tMap->setPhpName("Mailman");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("mailman_mailman_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("MAILMAN_ID", "MailmanId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("PROJECT_ID", "ProjectId", "int", CreoleTypes::INTEGER, "project" , "PROJECT_ID", true);
		$tMap->addColumn("LIST_NAME", "ListName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("IS_PUBLIC", "IsPublic", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("LIST_PASSWORD", "ListPassword", "string", CreoleTypes::VARCHAR, false, 16);
		$tMap->addForeignKey("CREATED_BY", "CreatedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("STATUS", "Status", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("LIST_DESCRIPTION", "ListDescription", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("CREATE_DATE", "CreateDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("BYTES_USED", "BytesUsed", "double", CreoleTypes::FLOAT, false, null);
				
    }
}
