<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Mailman
//
require_once('plugins/mailman/lib/MailmanPeer.php');
require_once('plugins/mailman/lib/Mailman.php');
require_once('html/Paginator.php');

$session = Session::getSession();
$Lang = $session->getLanguage();
$User = $session->getUser();

require_once('plugins/mailman/lib/html/MailmanTemplate.php');
$theme = new MailmanTemplate();

$Project = GFUrl::getUrl()->getProject();

if(is_object($User)) {
	$isProjectMember=$User->isProjectMember($Project);
} else {
	$isProjectMember=false;
}

$params = array(
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Mailman.BrowsePageTitle')
		);
$theme->header($params);

//make paginator code
$total=0;
$default_sort_by=MailmanPeer::LIST_NAME;

$columns = array(
MailmanPeer::LIST_NAME=>$Lang->getText('Mailman.ListNameName'),
MailmanPeer::LIST_DESCRIPTION=>$Lang->getText('Mailman.DescriptionName'),
MailmanPeer::CREATE_DATE=>$Lang->getText('Mailman.CreateDateName'),
$Lang->getText('Mailman.SubscriptionName')
);

// Retrieve the objects array
$crit = new Criteria();
$crit->add(MailmanPeer::PROJECT_ID, $Project->getProjectId());
$total = MailmanPeer::doCount($crit);

$paginator = new Paginator('br_mailmans', -1, $total, $default_sort_by, $columns);

$paginator->addPageClauses($crit);

$arr = MailmanPeer::doSelect($crit);

$theader = $paginator->getSortableTableHeaders($theme);

echo $theme->tableTop($theader);
$url = GFUrl::getUrl();

if (count($arr) < 1) {
	echo $theme->tableFullRow($Lang->getText('Mailman.NoneFound').' '.$Project->getProjectName());
} else {
	$bol_accessible = false;
	foreach ($arr as $item) {
		if ($item->userCanRead()) {
			$bol_accessible = true;
			$trow = array();	
			//can't click on lists that aren't activated yet
			if($item->getStatus() == Mailman::STATUS_REQUESTED) {				
				$trow[]='<img src="/images/mailman_icon.gif" height="16" width="16" border="0" /> '.$item->getListName();
				$trow[]=$item->getListDescription();
				$trow[]=$item->getCreateDate();
				$trow[]=$Lang->getText('Mailman.NotActivatedYet');
			} else {				
				$trow[]='<img src="/images/mailman_icon.gif" height="16" width="16" border="0" /> '.$item->getListName();
//				$trow[]= '<a href="'.$url->currentBaseUrl('ListThreads', array('mailman_id' => $item->getPrimaryKey())).'"><img src="/images/mailman_icon.gif" height="16" width="16" border="0" />&nbsp;'.$Lang->getText('Mailman.Archives', array($item->getListName())).'</a>';
				$trow[] = $item->getListDescription();
				$trow[] = $item->getCreateDate();			
				$trow[]='<a href="'.$url->buildUrl('/mailman/listinfo/'.$item->getListName()).'">'. $Lang->getText('Mailman.Subscription').'</a>';
			}
			
			echo $theme->tableRow($trow, array(), false);
		}
	}
	if ($bol_accessible == false) {
		echo $theme->tableFullRow($Lang->getText('Mailman.NoneFound').' '.$Project->getProjectName());
	}
	//echo $theme->listPaginatorRow($paginator);
}
if ($Project->userIsAdmin()) {
	$button_enabled = true;
} else {
	$button_enabled = false;
}

echo $theme->tableBottom(array(GFUrl::getURL()->projectUrl($Project,'','mailman','admin',array())=>$Lang->getText('Mailman.ManageLists')),array($button_enabled));

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}

	
$theme->footer($params);
?>
