<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/Project.php';
// (on-demand) include_once 'core/ProjectPeer.php';
 

// (on-demand) include_once 'plugins/scm/lib/ScmServer.php';
// (on-demand) include_once 'plugins/scm/lib/ScmServerPeer.php';

include_once 'plugins/scm/lib/ProjectScmPeer.php';

/**
 * Base class that represents a row from the 'project_scm' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to ProjectScm class. 
 * 
 * @package plugins.scm.lib 
 */
abstract class BaseProjectScm extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var ProjectScmPeer
	 */
	protected static $peer;

	/**
	 * The value for the project_id field.
	 * @var int	  
	 */
	protected $project_id;	

	/**
	 * The value for the enable_anonread field.
	 * @var boolean	  
	 */
	protected $enable_anonread = true;	

	/**
	 * The value for the scm_server_id field.
	 * @var int	  
	 */
	protected $scm_server_id;	

	/**
	 * The value for the controlled field.
	 * @var boolean	  
	 */
	protected $controlled = true;	

	/**
	 * The value for the hostname field.
	 * @var string	  
	 */
	protected $hostname;	

	/**
	 * The value for the root_directory field.
	 * @var string	  
	 */
	protected $root_directory;	

	/**
	 * The value for the external_browse_url field.
	 * @var string	  
	 */
	protected $external_browse_url;	

	/**
	 * The value for the browse_text field.
	 * @var string	  
	 */
	protected $browse_text;	

	/**
	 * The value for the access_text field.
	 * @var string	  
	 */
	protected $access_text;	

	/**
	 * The value for the bytes_used field.
	 * @var double	  
	 */
	protected $bytes_used;	
  
	/**
	 * Get the ProjectId column value.
	 *  
	 * @return int	  
	 */
	public function getProjectId()
	{
		return $this->project_id;
	}


	/**
	 * Set the value of `project_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setProjectId($v)
	{
		if ($this->project_id !== $v) {
			$this->project_id = $v;
			$this->modifiedColumns[] = ProjectScmPeer::PROJECT_ID;
		}
			
		if ($this->aProject !== null && $this->aProject->getProjectId() !== $v) {
			$this->aProject = null;
		}
			
	}

  
	/**
	 * Get the EnableAnonread column value.
	 *  
	 * @return boolean	  
	 */
	public function getEnableAnonread()
	{
		return $this->enable_anonread;
	}


	/**
	 * Set the value of `enable_anonread` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setEnableAnonread($v)
	{
		if ($this->enable_anonread !== $v || $v === true) {
			$this->enable_anonread = $v;
			$this->modifiedColumns[] = ProjectScmPeer::ENABLE_ANONREAD;
		}
				
	}

  
	/**
	 * Get the ScmServerId column value.
	 *  
	 * @return int	  
	 */
	public function getScmServerId()
	{
		return $this->scm_server_id;
	}


	/**
	 * Set the value of `scm_server_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setScmServerId($v)
	{
		if ($this->scm_server_id !== $v) {
			$this->scm_server_id = $v;
			$this->modifiedColumns[] = ProjectScmPeer::SCM_SERVER_ID;
		}
			
		if ($this->aScmServer !== null && $this->aScmServer->getScmServerId() !== $v) {
			$this->aScmServer = null;
		}
			
	}

  
	/**
	 * Get the Controlled column value.
	 *  
	 * @return boolean	  
	 */
	public function getControlled()
	{
		return $this->controlled;
	}


	/**
	 * Set the value of `controlled` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setControlled($v)
	{
		if ($this->controlled !== $v || $v === true) {
			$this->controlled = $v;
			$this->modifiedColumns[] = ProjectScmPeer::CONTROLLED;
		}
				
	}

  
	/**
	 * Get the Hostname column value.
	 *  
	 * @return string	  
	 */
	public function getHostname()
	{
		return $this->hostname;
	}


	/**
	 * Set the value of `hostname` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setHostname($v)
	{
		if ($this->hostname !== $v) {
			$this->hostname = $v;
			$this->modifiedColumns[] = ProjectScmPeer::HOSTNAME;
		}
				
	}

  
	/**
	 * Get the RootDirectory column value.
	 *  
	 * @return string	  
	 */
	public function getRootDirectory()
	{
		return $this->root_directory;
	}


	/**
	 * Set the value of `root_directory` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setRootDirectory($v)
	{
		if ($this->root_directory !== $v) {
			$this->root_directory = $v;
			$this->modifiedColumns[] = ProjectScmPeer::ROOT_DIRECTORY;
		}
				
	}

  
	/**
	 * Get the ExternalBrowseUrl column value.
	 *  
	 * @return string	  
	 */
	public function getExternalBrowseUrl()
	{
		return $this->external_browse_url;
	}


	/**
	 * Set the value of `external_browse_url` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setExternalBrowseUrl($v)
	{
		if ($this->external_browse_url !== $v) {
			$this->external_browse_url = $v;
			$this->modifiedColumns[] = ProjectScmPeer::EXTERNAL_BROWSE_URL;
		}
				
	}

  
	/**
	 * Get the BrowseText column value.
	 *  
	 * @return string	  
	 */
	public function getBrowseText()
	{
		return $this->browse_text;
	}


	/**
	 * Set the value of `browse_text` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setBrowseText($v)
	{
		if ($this->browse_text !== $v) {
			$this->browse_text = $v;
			$this->modifiedColumns[] = ProjectScmPeer::BROWSE_TEXT;
		}
				
	}

  
	/**
	 * Get the AccessText column value.
	 *  
	 * @return string	  
	 */
	public function getAccessText()
	{
		return $this->access_text;
	}


	/**
	 * Set the value of `access_text` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setAccessText($v)
	{
		if ($this->access_text !== $v) {
			$this->access_text = $v;
			$this->modifiedColumns[] = ProjectScmPeer::ACCESS_TEXT;
		}
				
	}

  
	/**
	 * Get the BytesUsed column value.
	 *  
	 * @return double	  
	 */
	public function getBytesUsed()
	{
		return $this->bytes_used;
	}


	/**
	 * Set the value of `bytes_used` column.	  
	 *  
	 * @param double $v new value
	 * @return void
	 *  
	 */
	public function setBytesUsed($v)
	{
		if ($this->bytes_used !== $v) {
			$this->bytes_used = $v;
			$this->modifiedColumns[] = ProjectScmPeer::BYTES_USED;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->project_id = $rs->getInt($startcol + 0);					
			$this->enable_anonread = $rs->getBoolean($startcol + 1);					
			$this->scm_server_id = $rs->getInt($startcol + 2);					
			$this->controlled = $rs->getBoolean($startcol + 3);					
			$this->hostname = $rs->getString($startcol + 4);					
			$this->root_directory = $rs->getString($startcol + 5);					
			$this->external_browse_url = $rs->getString($startcol + 6);					
			$this->browse_text = $rs->getString($startcol + 7);					
			$this->access_text = $rs->getString($startcol + 8);					
			$this->bytes_used = $rs->getFloat($startcol + 9);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating ProjectScm object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(ProjectScmPeer::DATABASE_NAME);
		$criteria->add(ProjectScmPeer::PROJECT_ID, $this->project_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(ProjectScmPeer::DATABASE_NAME);
		if ($this->isColumnModified(ProjectScmPeer::PROJECT_ID)) $criteria->add(ProjectScmPeer::PROJECT_ID, $this->project_id);
		if ($this->isColumnModified(ProjectScmPeer::ENABLE_ANONREAD)) $criteria->add(ProjectScmPeer::ENABLE_ANONREAD, $this->enable_anonread);
		if ($this->isColumnModified(ProjectScmPeer::SCM_SERVER_ID)) $criteria->add(ProjectScmPeer::SCM_SERVER_ID, $this->scm_server_id);
		if ($this->isColumnModified(ProjectScmPeer::CONTROLLED)) $criteria->add(ProjectScmPeer::CONTROLLED, $this->controlled);
		if ($this->isColumnModified(ProjectScmPeer::HOSTNAME)) $criteria->add(ProjectScmPeer::HOSTNAME, $this->hostname);
		if ($this->isColumnModified(ProjectScmPeer::ROOT_DIRECTORY)) $criteria->add(ProjectScmPeer::ROOT_DIRECTORY, $this->root_directory);
		if ($this->isColumnModified(ProjectScmPeer::EXTERNAL_BROWSE_URL)) $criteria->add(ProjectScmPeer::EXTERNAL_BROWSE_URL, $this->external_browse_url);
		if ($this->isColumnModified(ProjectScmPeer::BROWSE_TEXT)) $criteria->add(ProjectScmPeer::BROWSE_TEXT, $this->browse_text);
		if ($this->isColumnModified(ProjectScmPeer::ACCESS_TEXT)) $criteria->add(ProjectScmPeer::ACCESS_TEXT, $this->access_text);
		if ($this->isColumnModified(ProjectScmPeer::BYTES_USED)) $criteria->add(ProjectScmPeer::BYTES_USED, $this->bytes_used);
		return $criteria;			
	}
	
	

	/**
	 * @var Project	  
	 */
	protected $aProject;

	/**
	 * Declares an association between this object and a Project object
	 *
	 * @param Project $v
	 * @return void
	 * @throws PropelException
	 */
	public function setProject($v)
	{
			
		if ($v === null) {
			$this->setProjectId(NULL);
		} else {
			$this->setProjectId($v->getProjectId());
		}
   
		$this->aProject = $v;
	}


	/**
	 * Get the associated Project object
	 *
	 * @param Connection Optional Connection object.
	 * @return Project The associated Project object.
	 * @throws PropelException
	 */
	public function getProject($con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPeer.php';

		if ($this->aProject === null && ($this->project_id !== null)) {
	
			$this->aProject = ProjectPeer::retrieveByPK($this->project_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ProjectPeer::retrieveByPK($this->project_id, $con);
			   $obj->addProjectScms($this);
			 */
		}
		return $this->aProject;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setProjectKey($key)
	{

		$this->setProjectId( (int) $key);			
		
	}

	/**
	 * @var ScmServer	  
	 */
	protected $aScmServer;

	/**
	 * Declares an association between this object and a ScmServer object
	 *
	 * @param ScmServer $v
	 * @return void
	 * @throws PropelException
	 */
	public function setScmServer($v)
	{
			
		if ($v === null) {
			$this->setScmServerId(NULL);
		} else {
			$this->setScmServerId($v->getScmServerId());
		}
   
		$this->aScmServer = $v;
	}


	/**
	 * Get the associated ScmServer object
	 *
	 * @param Connection Optional Connection object.
	 * @return ScmServer The associated ScmServer object.
	 * @throws PropelException
	 */
	public function getScmServer($con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmServerPeer.php';

		if ($this->aScmServer === null && ($this->scm_server_id !== null)) {
	
			$this->aScmServer = ScmServerPeer::retrieveByPK($this->scm_server_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = ScmServerPeer::retrieveByPK($this->scm_server_id, $con);
			   $obj->addProjectScms($this);
			 */
		}
		return $this->aScmServer;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setScmServerKey($key)
	{

		$this->setScmServerId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("project_id", "enable_anonread", "scm_server_id", "controlled", "hostname", "root_directory", "external_browse_url", "browse_text", "access_text", "bytes_used", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case ProjectScmPeer::PROJECT_ID:
				return $this->getProjectId();
				break;
		  
			case ProjectScmPeer::ENABLE_ANONREAD:
				return $this->getEnableAnonread();
				break;
		  
			case ProjectScmPeer::SCM_SERVER_ID:
				return $this->getScmServerId();
				break;
		  
			case ProjectScmPeer::CONTROLLED:
				return $this->getControlled();
				break;
		  
			case ProjectScmPeer::HOSTNAME:
				return $this->getHostname();
				break;
		  
			case ProjectScmPeer::ROOT_DIRECTORY:
				return $this->getRootDirectory();
				break;
		  
			case ProjectScmPeer::EXTERNAL_BROWSE_URL:
				return $this->getExternalBrowseUrl();
				break;
		  
			case ProjectScmPeer::BROWSE_TEXT:
				return $this->getBrowseText();
				break;
		  
			case ProjectScmPeer::ACCESS_TEXT:
				return $this->getAccessText();
				break;
		  
			case ProjectScmPeer::BYTES_USED:
				return $this->getBytesUsed();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getProjectId();
				break;
  
			case 1:
				return $this->getEnableAnonread();
				break;
  
			case 2:
				return $this->getScmServerId();
				break;
  
			case 3:
				return $this->getControlled();
				break;
  
			case 4:
				return $this->getHostname();
				break;
  
			case 5:
				return $this->getRootDirectory();
				break;
  
			case 6:
				return $this->getExternalBrowseUrl();
				break;
  
			case 7:
				return $this->getBrowseText();
				break;
  
			case 8:
				return $this->getAccessText();
				break;
  
			case 9:
				return $this->getBytesUsed();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(ProjectScmPeer::PROJECT_ID, $arr)) $this->setProjectId($arr[ProjectScmPeer::PROJECT_ID]);
  
		if (array_key_exists(ProjectScmPeer::ENABLE_ANONREAD, $arr)) $this->setEnableAnonread($arr[ProjectScmPeer::ENABLE_ANONREAD]);
  
		if (array_key_exists(ProjectScmPeer::SCM_SERVER_ID, $arr)) $this->setScmServerId($arr[ProjectScmPeer::SCM_SERVER_ID]);
  
		if (array_key_exists(ProjectScmPeer::CONTROLLED, $arr)) $this->setControlled($arr[ProjectScmPeer::CONTROLLED]);
  
		if (array_key_exists(ProjectScmPeer::HOSTNAME, $arr)) $this->setHostname($arr[ProjectScmPeer::HOSTNAME]);
  
		if (array_key_exists(ProjectScmPeer::ROOT_DIRECTORY, $arr)) $this->setRootDirectory($arr[ProjectScmPeer::ROOT_DIRECTORY]);
  
		if (array_key_exists(ProjectScmPeer::EXTERNAL_BROWSE_URL, $arr)) $this->setExternalBrowseUrl($arr[ProjectScmPeer::EXTERNAL_BROWSE_URL]);
  
		if (array_key_exists(ProjectScmPeer::BROWSE_TEXT, $arr)) $this->setBrowseText($arr[ProjectScmPeer::BROWSE_TEXT]);
  
		if (array_key_exists(ProjectScmPeer::ACCESS_TEXT, $arr)) $this->setAccessText($arr[ProjectScmPeer::ACCESS_TEXT]);
  
		if (array_key_exists(ProjectScmPeer::BYTES_USED, $arr)) $this->setBytesUsed($arr[ProjectScmPeer::BYTES_USED]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case ProjectScmPeer::PROJECT_ID:
				$this->setProjectId($value);
				break;
	  
			case ProjectScmPeer::ENABLE_ANONREAD:
				$this->setEnableAnonread($value);
				break;
	  
			case ProjectScmPeer::SCM_SERVER_ID:
				$this->setScmServerId($value);
				break;
	  
			case ProjectScmPeer::CONTROLLED:
				$this->setControlled($value);
				break;
	  
			case ProjectScmPeer::HOSTNAME:
				$this->setHostname($value);
				break;
	  
			case ProjectScmPeer::ROOT_DIRECTORY:
				$this->setRootDirectory($value);
				break;
	  
			case ProjectScmPeer::EXTERNAL_BROWSE_URL:
				$this->setExternalBrowseUrl($value);
				break;
	  
			case ProjectScmPeer::BROWSE_TEXT:
				$this->setBrowseText($value);
				break;
	  
			case ProjectScmPeer::ACCESS_TEXT:
				$this->setAccessText($value);
				break;
	  
			case ProjectScmPeer::BYTES_USED:
				$this->setBytesUsed($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setProjectId($value);
				break;
  
			case 1:
				$this->setEnableAnonread($value);
				break;
  
			case 2:
				$this->setScmServerId($value);
				break;
  
			case 3:
				$this->setControlled($value);
				break;
  
			case 4:
				$this->setHostname($value);
				break;
  
			case 5:
				$this->setRootDirectory($value);
				break;
  
			case 6:
				$this->setExternalBrowseUrl($value);
				break;
  
			case 7:
				$this->setBrowseText($value);
				break;
  
			case 8:
				$this->setAccessText($value);
				break;
  
			case 9:
				$this->setBytesUsed($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(ProjectScmPeer::DATABASE_NAME);

		try {
			$con->begin();
			ProjectScmPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(ProjectScmPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aProject !== null) {
				if ($this->aProject->isModified()) $this->aProject->save($con);
				$this->setProject($this->aProject);
			}
 
			if ($this->aScmServer !== null) {
				if ($this->aScmServer->isModified()) $this->aScmServer->save($con);
				$this->setScmServer($this->aScmServer);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = ProjectScmPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					ProjectScmPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return ProjectScmPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aProject !== null) {
				if (($retval = $this->aProject->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aScmServer !== null) {
				if (($retval = $this->aScmServer->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = ProjectScmPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed project_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setProjectId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getProjectId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return ProjectScm Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new ProjectScm();
		$copyObj->setEnableAnonread($this->enable_anonread);
		$copyObj->setScmServerId($this->scm_server_id);
		$copyObj->setControlled($this->controlled);
		$copyObj->setHostname($this->hostname);
		$copyObj->setRootDirectory($this->root_directory);
		$copyObj->setExternalBrowseUrl($this->external_browse_url);
		$copyObj->setBrowseText($this->browse_text);
		$copyObj->setAccessText($this->access_text);
		$copyObj->setBytesUsed($this->bytes_used);
		
		$copyObj->setNew(true);
		
		$copyObj->setProjectId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return ProjectScmPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new ProjectScmPeer();
		}
		return self::$peer;
	}

}
