<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/tracker/lib/TrackerItemQuery.php');
require_once('lib/exceptions/NotLoggedInException.php');

class TrackerItemQuickQuery extends TrackerItemQuery {

	function __construct(Tracker $Tracker) {
		parent::__construct($Tracker);
		$this->setupItems();
	}

	private function setupItems() {
		$fields = array();
		if (isset($_REQUEST['quickquery'])) {
			if (!Session::getSession()->isLoggedin()) {
				throw new NotLoggedInException();
			}
			if (isset($_REQUEST['tracker_item_id']) && intval($_REQUEST['tracker_item_id']) > 0) {
				$fields['tracker_item_id']=intval($_REQUEST['tracker_item_id']);
				//if the ID was given, ignore the other fields
			} else {
				$fields['priority']=intval($_REQUEST['priority']);
				$fields['assigned_to']=intval($_REQUEST['assigned_to']);
				$fields['summary']=Validator::sanitizeString(addslashes($_REQUEST['summary']));
	//			$fields['moddaterange']=$_REQUEST['moddaterange'];
	//			$fields['closedaterange']=$_REQUEST['closedaterange'];
	//			$fields['opendaterange']=$_REQUEST['opendaterange'];
				if (isset($_REQUEST['extra_field'])) 
					$fields['extrafields']=$_REQUEST['extra_field'];
			}
			$fields['sortcol']=$_REQUEST['sortcol'];
			$fields['sortord']=$_REQUEST['sortord'];
//			if (Session::getSession()->isLoggedin()) {
				$usr = Session::getSession()->getUser();
				$usr->setPreference('quickquery'.$this->Tracker->getTrackerId(),serialize($fields));
/*			} else {
//save in the session
				$_SESSION['quickquery'.$this->Tracker->getTrackerId()]=serialize($fields);
			}*/
		} elseif (Session::getSession()->isLoggedin()) {
//logged in user may have a saved preference
			$usr = Session::getSession()->getUser();
			if ($usr->getPreference('quickquery'.$this->Tracker->getTrackerId())) {
				$pref = $usr->getPreference('quickquery'.$this->Tracker->getTrackerId());
				$fields = unserialize($pref);
			}
/*		} elseif (isset($_SESSION['quickquery'.$this->Tracker->getTrackerId()])) {
//non logged in users may have a saved session var
			$fields=unserialize($_SESSION['quickquery'.$this->Tracker->getTrackerId()]);
*/
		} else {
//echo "No Saved Fields";
		}
		if (count($fields) < 1) {
//use default fields
//echo "USING DEFAULT FIELDS";

		}
		if (isset($fields['tracker_item_id']) && $fields['tracker_item_id'] > 0) {
			$this->tracker_item_id=$fields['tracker_item_id'];
		}
		if (isset($fields['assigned_to'])) {
			$this->assignee=$fields['assigned_to'];
		}
		if (isset($fields['summary'])) {
			$this->summary=$fields['summary'];
		}
/*
		if (isset($fields['moddaterange'])) {
			$this->moddaterange=$fields['moddaterange'];
		}
		if (isset($fields['closedaterange'])) {
			$this->closedaterange=$fields['closedaterange'];
		}
		if (isset($fields['opendaterange'])) {
			$this->opendaterange=$fields['opendaterange'];
		}
*/
		if (isset($fields['sortcol'])) {
			$this->sortcol=$fields['sortcol'];
		}
		if (isset($fields['sortord'])) {
			$this->sortord=$fields['sortord'];
		}
		if (isset($fields['extrafields'])) {
			$this->extra_fields=$fields['extrafields'];
		}
		if (isset($fields['priority'])) {
			$this->priority=$fields['priority'];
		}
	//	return $this->getTrackerItems();
	}

}

?>
