<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists TrackerExtraFieldElementTransition
//
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransitionPeer.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerExtraFieldElementTransition.BrowsePageTitle')
		);
$theme->header($params);

$con=Propel::getConnection();
$stmt=$con->createStatement();
$sql="SELECT tef.tracker_extra_field_id,tef.field_name,tefe.element_id,
	tefe.element_name,tefet.tracker_extra_field_element_transition_id
FROM tracker_extra_field tef NATURAL JOIN tracker_extra_field_element TEFE NATURAL JOIN 
tracker_extra_field_element_transition tefet, tracker_extra_field_element AS tefe2
WHERE tef.tracker_id='".$Tracker->getTrackerId()."'
AND tef.use_workflow='t'
AND tefet.to_element_id=tefe2.element_id
ORDER BY tef.field_order,tefe.sort_order,tefe2.sort_order";

$rs=$stmt->executeQuery($sql);

$dfields=array();
$delements=array();
$data=array();
while ($rs->next()) {
	$data[]=$rs->getRow();
}
//print_r($data);
foreach ($data as $d) {
	$dfields[$d['tracker_extra_field_id']][]=1;
	$delements[$d['element_id']][]=1;
}
//print_r($dfields);
//print_r($delements);
$theader = array();

$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.FieldName');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.FromElementIdName');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.ToElementIdName');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Roles');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Fields');
$theader[] = $Lang->getText('TrackerExtraFieldElementTransition.Notify');

echo $theme->tableTop($theader);

if (count($dfields) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('TrackerExtraFieldElementTransition.NoneFound').'</span>');
} else {
	$last_field='';
	$last_element='';
	reset($data);
	foreach ($data as $d) {
		$trow = array();
		$tmod = array();
		if ($d['tracker_extra_field_id'] != $last_field) {
			$trow[]=$d['field_name'];
			$tmod[]='rowspan="'.count($dfields[$d['tracker_extra_field_id']]).'"';
			$last_field=$d['tracker_extra_field_id'];
		}
		if ($d['element_id'] != $last_element) {
			$trow[]=$d['element_name'];
			$tmod[]='rowspan="'.count($delements[$d['element_id']]).'"';
			$last_element=$d['element_id'];
		}
		$item = TrackerExtraFieldElementTransitionPeer::retrieveByPk($d['tracker_extra_field_element_transition_id']);
		$trow[]=TrackerExtraFieldElementPeer::retrieveByPk($item->getToElementId())->getElementName();
		$tmod[]='';
		$roles=$item->getTrackerExtraFieldElementTransitionRolesJoinRole();
		$rolearr=array();
		foreach ($roles as $role) {
			$rolearr[]=$role->getRole()->getRoleName();
		}
		$trow[]=implode(',',$rolearr);;
		$tmod[]='';
		$fields=$item->getTrackerExtraFieldElementTransitionFieldsJoinTrackerExtraField();
		$fieldarr=array();
		foreach ($fields as $field) {
			$fieldarr[]=$field->getTrackerExtraField()->getFieldName();
		}
		$trow[]=implode(',',$fieldarr);
		$tmod[]='';

		$roles=$item->getTrackerExtraFieldElementTransitionNotifysJoinRole();
		$rolearr=array();
		foreach ($roles as $role) {
			$rolearr[]=$role->getRole()->getRoleName();		
		}
		$trow[]=implode(',',$rolearr);;
		$tmod[]='';
		echo $theme->tableRow($trow,$tmod);
		$trow = array();
		$tmod = array();
	}
}

echo $theme->tableBottom();

$theme->footer($params);

?>
