<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for $OBJECT deletion
//
require_once('plugins/tracker/lib/TrackerQueryPeer.php');
require_once('plugins/tracker/lib/TrackerQuery.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

//must be logged in
if (!$session->isLoggedIn()) {
      throw new NotLoggedInException();
}

$Project = GFUrl::getUrl()->getProject();
$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
$crit = new Criteria();
$crit->add(TrackerQueryPeer::USER_ID, $session->getUser()->getID());
$crit->add(TrackerQueryPeer::TRACKER_QUERY_ID,$_REQUEST['tracker_query_id']);
$arr = $Tracker->getTrackerQuerys($crit);
$obj=$arr[0];
if (!is_object($obj)) {
      throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('TrackerQuery.DeletePageTitle')
		);

include('forms/TrackerQueryDelete-tpl.php');

?>