<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('plugins/tracker/lib/TrackerExtraField.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElement.php');
require_once('plugins/tracker/lib/TrackerExtraFieldElementTransition.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

if (!isset($_GET['tracker_extra_field_id'])) {
	throw new MissingDataException();
}

$extra_field = TrackerExtraFieldPeer::retrieveByPk($_GET['tracker_extra_field_id']);
$tracker = $extra_field->getTracker();
if (!$tracker->userIsAdmin()) {
	throw new PermissionDeniedException();
}

// First, see which transitions were unchecked and delete them
$c = new Criteria();
$c->add(TrackerExtraFieldElementPeer::TRACKER_EXTRA_FIELD_ID, $_GET['tracker_extra_field_id']);
$c->addJoin(TrackerExtraFieldElementTransitionPeer::ELEMENT_ID, TrackerExtraFieldElementPeer::ELEMENT_ID);

$transitions = TrackerExtraFieldElementTransitionPeer::doSelect($c);
$existing_transitions = array();
foreach ($transitions as $transition) {
	$from_element_id = $transition->getElementId();
	$to_element_id = $transition->getToElementId();
	if (!array_key_exists($from_element_id,$_POST['matrix']) || !array_key_exists($to_element_id,$_POST['matrix'][$from_element_id])) {
		$transition->delete();
	} else {
		// Save for future reference
		$existing_transitions[$from_element_id][] = $to_element_id;
	}
}

foreach ($_POST['matrix'] as $from_element_id => $to_elements_id) {
	foreach ($to_elements_id as $to_element_id => $foo) {
		// If the transition already exists on the database, skip it
		if (array_key_exists($from_element_id, $existing_transitions) && in_array($to_element_id, $existing_transitions[$from_element_id])) {
			continue;
		}
		
		// Create the transition
		$transition = new TrackerExtraFieldElementTransition();
		$transition->setElementId($from_element_id);
		$transition->setToElementId($to_element_id);
		$transition->save();
	}
}
	
GFUrl::getUrl()->redirect(GFUrl::getUrl()->currentBaseURL('WorkflowMatrix'), array('feedback' => $language->getText('WorkflowMatrix.SaveFeedback'),'tracker_extra_field_id'=>$_REQUEST['tracker_extra_field_id']));

?>