<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Federico Tarantini	federico@gforgegroup.com 
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('plugins/tracker/lib/html/TrackerTemplate.php');
require_once('plugins/tracker/lib/TrackerItemQuickQuery.php');

$session = Session::getSession();
$url = GFUrl::getUrl();
$project = $url->getProject();
$user = $session->getUser();

$template = new TrackerTemplate();

$Tracker = TrackerPeer::retrieveByPk($_REQUEST['tracker_id']);
if (!is_object($Tracker) || !$Tracker->userCanRead()) {
        throw new PermissionDeniedException();
}

echo popupHeader($template, 'Browse Tracker Items');

$mode=(isset($_REQUEST['field']) ? $_REQUEST['field'] : '' );

$theader = array();
$theader[] = Language::getSessText('TrackerItemRelationPopup.ItemNumber');
$theader[] = Language::getSessText('TrackerItemRelationPopup.Summary');
echo $template->tableTop($theader);

//get tracker items
$show = ((isset($_REQUEST['show'])) ? Validator::sanitizeInt($_REQUEST['show']) : 100 );
if (!isset($_GET['start'])) {
	$start = 0;
} else {
	$start = Validator::sanitizeInt($_GET['start']);
}
//get total count
$sql="SELECT count(*) AS count FROM tracker_item WHERE tracker_id='".$Tracker->getTrackerId()."'";
$rs=Propel::getConnection()->createStatement()->executeQuery($sql,ResultSet::FETCHMODE_ASSOC);
$rs->next();
$totalcount=$rs->getInt('count');
//get just the requested limit
$sql="SELECT * FROM tracker_item WHERE tracker_id='".$Tracker->getTrackerId()."' ORDER BY tracker_item_id LIMIT $show OFFSET $start";
$rs=Propel::getConnection()->createStatement()->executeQuery($sql,ResultSet::FETCHMODE_NUM);
$arr=TrackerItemPeer::populateObjects($rs);

if (count($arr) > 0) {
	foreach ($arr as $tracker_item) {
		$cols = array();
		$cols[] = $tracker_item->getTrackerItemId();
		$cols[] = '<a href="#" onclick="
		if(window.opener.document.TrackerItemEdit.'.$mode.'.value.length > 0) {
		    window.opener.document.TrackerItemEdit.'.$mode.'.value = window.opener.document.TrackerItemEdit.'.$mode.'.value + \','.$tracker_item->getTrackerItemId().'\';
		} else {
		    window.opener.document.TrackerItemEdit.'.$mode.'.value = \''.$tracker_item->getTrackerItemId().'\';
		}
		window.close();">'.$tracker_item->getSummary().'</a>';
		echo $template->tableRow($cols);
	}
} else {
	echo $template->tableFullRow(Language::getSessText('TrackerItemRelationPopup.NoTrackerItems'));
}
echo $template->tableBottom();

	//
	//	Pagination code
	//
	$pages = $totalcount / $show;
	$currentpage = intval($start / $show);
	$skipped_pages=false;
	for ($j=0; $j<$pages; $j++) {
		if ($pages > 20) {
			if ((($j > 4) && ($j < ($currentpage-5))) || (($j > ($currentpage+5)) && ($j < ($pages-5)))) {
				if (!$skipped_pages) {
					$skipped_pages=true;
					echo "....&nbsp;";
				}
				continue;
			} else {
				$skipped_pages=false;
			}
		}
		if ($j == $currentpage) {
			echo '<strong>'.($j+1).'</strong>&nbsp;';
		} else {
			echo '<a href="'.GFUrl::getUrl()->currentBaseUrl('TrackerItemList').'&amp;tracker_id='.$Tracker->getTrackerId().'&amp;field='.$mode.'&amp;start='.($j*$show).'">'.($j+1).'</a>&nbsp;';
		}
	}

echo popupFooter();

?>
