<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'wiki_version' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.wiki.lib.map
 */
class UserWikiVersionMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.userwiki.lib.map.UserWikiVersionMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("wiki_version");
		$tMap->setPhpName("WikiVersion");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("wiki_version_wiki_version_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("WIKI_VERSION_ID", "WikiVersionId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("WIKI_PAGE_ID", "WikiPageId", "int", CreoleTypes::INTEGER, "wiki_page" , "WIKI_PAGE_ID", true);
		$tMap->addColumn("PAGE_VERSION", "PageVersion", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addForeignKey("POSTED_BY", "PostedBy", "int", CreoleTypes::INTEGER, "user" , "USER_ID", true);
		$tMap->addColumn("REFS", "Refs", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("LAST_MODIFIED_DATE", "LastModifiedDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("SCORE", "Score", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("HITS", "Hits", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("CREATE_DATE", "CreateDate", "int", CreoleTypes::TIMESTAMP, false, null);
				
    }
}
