<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'plugins/userwiki/lib/WikiPagePeer.php';

/**
 * Base class that represents a row from the 'wiki_page' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to WikiPage class. 
 * 
 * @package plugins.wiki.lib 
 */
abstract class BaseUserWikiPage extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var WikiPagePeer
	 */
	protected static $peer;

	/**
	 * The value for the wiki_page_id field.
	 * @var int	  
	 */
	protected $wiki_page_id;	

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the pagename field.
	 * @var string	  
	 */
	protected $pagename;	

	/**
	 * The value for the flags field.
	 * @var int	  
	 */
	protected $flags;	

	/**
	 * The value for the latest_version field.
	 * @var int	  
	 */
	protected $latest_version;	
  
	/**
	 * Get the WikiPageId column value.
	 *  
	 * @return int	  
	 */
	public function getWikiPageId()
	{
		return $this->wiki_page_id;
	}


	/**
	 * Set the value of `wiki_page_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setWikiPageId($v)
	{
		if ($this->wiki_page_id !== $v) {
			$this->wiki_page_id = $v;
			$this->modifiedColumns[] = WikiPagePeer::WIKI_PAGE_ID;
		}
			
		  // update associated UserWikiPageLink		  
		  if ($this->collWikiPageLinksRelatedByFromWikiPageId !== null) {
			  for ($i=0,$size=count($this->collWikiPageLinksRelatedByFromWikiPageId); $i < $size; $i++) {
				  $this->collWikiPageLinksRelatedByFromWikiPageId[$i]->setFromWikiPageId($v);
			  }
		  }
			  	
		  // update associated WikiPageLink		  
		  if ($this->collWikiPageLinksRelatedByToWikiPageId !== null) {
			  for ($i=0,$size=count($this->collWikiPageLinksRelatedByToWikiPageId); $i < $size; $i++) {
				  $this->collWikiPageLinksRelatedByToWikiPageId[$i]->setToWikiPageId($v);
			  }
		  }
			  	
		  // update associated WikiVersion		  
		  if ($this->collWikiVersions !== null) {
			  for ($i=0,$size=count($this->collWikiVersions); $i < $size; $i++) {
				  $this->collWikiVersions[$i]->setWikiPageId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = WikiPagePeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = UserWikiPagePeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the Pagename column value.
	 *  
	 * @return string	  
	 */
	public function getPagename()
	{
		return $this->pagename;
	}


	/**
	 * Set the value of `pagename` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPagename($v)
	{
		if ($this->pagename !== $v) {
			$this->pagename = $v;
			$this->modifiedColumns[] = UserWikiPagePeer::PAGENAME;
		}
				
	}

  
	/**
	 * Get the Flags column value.
	 *  
	 * @return int	  
	 */
	public function getFlags()
	{
		return $this->flags;
	}


	/**
	 * Set the value of `flags` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setFlags($v)
	{
		if ($this->flags !== $v) {
			$this->flags = $v;
			$this->modifiedColumns[] = UserWikiPagePeer::FLAGS;
		}
				
	}

  
	/**
	 * Get the LatestVersion column value.
	 *  
	 * @return int	  
	 */
	public function getLatestVersion()
	{
		return $this->latest_version;
	}


	/**
	 * Set the value of `latest_version` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setLatestVersion($v)
	{
		if ($this->latest_version !== $v) {
			$this->latest_version = $v;
			$this->modifiedColumns[] = UserWikiPagePeer::LATEST_VERSION;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->wiki_page_id = $rs->getInt($startcol + 0);					
			$this->section = $rs->getString($startcol + 1);					
			$this->ref_id = $rs->getInt($startcol + 2);					
			$this->pagename = $rs->getString($startcol + 3);					
			$this->flags = $rs->getInt($startcol + 4);					
			$this->latest_version = $rs->getInt($startcol + 5);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating WikiPage object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(UserWikiPagePeer::DATABASE_NAME);
		$criteria->add(UserWikiPagePeer::WIKI_PAGE_ID, $this->wiki_page_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(UserWikiPagePeer::DATABASE_NAME);
		if ($this->isColumnModified(UserWikiPagePeer::WIKI_PAGE_ID)) $criteria->add(UserWikiPagePeer::WIKI_PAGE_ID, $this->wiki_page_id);
		if ($this->isColumnModified(UserWikiPagePeer::SECTION)) $criteria->add(UserWikiPagePeer::SECTION, $this->section);
		if ($this->isColumnModified(UserWikiPagePeer::REF_ID)) $criteria->add(UserWikiPagePeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(UserWikiPagePeer::PAGENAME)) $criteria->add(UserWikiPagePeer::PAGENAME, $this->pagename);
		if ($this->isColumnModified(UserWikiPagePeer::FLAGS)) $criteria->add(UserWikiPagePeer::FLAGS, $this->flags);
		if ($this->isColumnModified(UserWikiPagePeer::LATEST_VERSION)) $criteria->add(UserWikiPagePeer::LATEST_VERSION, $this->latest_version);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collWikiPageLinksRelatedByFromWikiPageId	  
	 * @var array
	 */
	protected $collWikiPageLinksRelatedByFromWikiPageId; 

	/**
	 * Temporary storage of collWikiPageLinksRelatedByFromWikiPageId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initWikiPageLinksRelatedByFromWikiPageId()
	{
		if ($this->collWikiPageLinksRelatedByFromWikiPageId === null) {
			$this->collWikiPageLinksRelatedByFromWikiPageId = array();
		}
	}

	/**
	 * Method called to associate a WikiPageLink object to this object
	 * through the WikiPageLink foreign key attribute
	 *
	 * @param WikiPageLink $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addWikiPageLinkRelatedByFromWikiPageId(UserWikiPageLink $l)
	{
		$this->collWikiPageLinksRelatedByFromWikiPageId[] = $l;
		$l->setWikiPageRelatedByFromWikiPageId($this);
	}

	/**
	 * The criteria used to select the current contents of collWikiPageLinksRelatedByFromWikiPageId.
	 * @var Criteria
	 */
	private $lastWikiPageLinksRelatedByFromWikiPageIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this WikiPage has previously
	 * been saved, it will retrieve related WikiPageLinksRelatedByFromWikiPageId from storage.
	 * If this WikiPage is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getWikiPageLinksRelatedByFromWikiPageId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiPageLinkPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collWikiPageLinksRelatedByFromWikiPageId === null) {
			if ($this->isNew()) {
			   $this->collWikiPageLinksRelatedByFromWikiPageId = array();
			} else {
	
				$criteria->add(UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID, $this->getWikiPageId() );

				$this->collWikiPageLinksRelatedByFromWikiPageId = UserWikiPageLinkPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID, $this->getWikiPageId());

				if (!isset($this->lastWikiPageLinksRelatedByFromWikiPageIdCriteria) || !$this->lastWikiPageLinksRelatedByFromWikiPageIdCriteria->equals($criteria)) {
					$this->collWikiPageLinksRelatedByFromWikiPageId = UserWikiPageLinkPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastWikiPageLinksRelatedByFromWikiPageIdCriteria = $criteria;

		return $this->collWikiPageLinksRelatedByFromWikiPageId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this WikiPage is new, it will return
	 * an empty collection; or if this WikiPage has previously
	 * been saved, it will retrieve related WikiPageLinksRelatedByFromWikiPageId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in WikiPage.
	 */
	public function getWikiPageLinksRelatedByFromWikiPageIdJoinWikiPageRelatedByToWikiPageId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiPageLinkPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collWikiPageLinksRelatedByFromWikiPageId === null) {
			if ($this->isNew()) {
			   $this->collWikiPageLinksRelatedByFromWikiPageId = array();
			} else {
	   
				$criteria->add(UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID, $this->getWikiPageId());
				$this->collWikiPageLinksRelatedByFromWikiPageId = UserWikiPageLinkPeer::doSelectJoinWikiPageRelatedByToWikiPageId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserWikiPageLinkPeer::FROM_WIKI_PAGE_ID, $this->getWikiPageId());
			if (!isset($this->lastWikiPageLinksRelatedByFromWikiPageIdCriteria) || !$this->lastWikiPageLinksRelatedByFromWikiPageIdCriteria->equals($criteria)) {
				$this->collWikiPageLinksRelatedByFromWikiPageId = UserWikiPageLinkPeer::doSelectJoinWikiPageRelatedByToWikiPageId($criteria, $con);
			}
		}
		$this->lastWikiPageLinksRelatedByFromWikiPageIdCriteria = $criteria;

		return $this->collWikiPageLinksRelatedByFromWikiPageId;
	}

	/**
	 * Collection to store aggregation of collWikiPageLinksRelatedByToWikiPageId	  
	 * @var array
	 */
	protected $collWikiPageLinksRelatedByToWikiPageId; 

	/**
	 * Temporary storage of collWikiPageLinksRelatedByToWikiPageId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initWikiPageLinksRelatedByToWikiPageId()
	{
		if ($this->collWikiPageLinksRelatedByToWikiPageId === null) {
			$this->collWikiPageLinksRelatedByToWikiPageId = array();
		}
	}

	/**
	 * Method called to associate a WikiPageLink object to this object
	 * through the WikiPageLink foreign key attribute
	 *
	 * @param WikiPageLink $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addWikiPageLinkRelatedByToWikiPageId(WikiPageLink $l)
	{
		$this->collWikiPageLinksRelatedByToWikiPageId[] = $l;
		$l->setWikiPageRelatedByToWikiPageId($this);
	}

	/**
	 * The criteria used to select the current contents of collWikiPageLinksRelatedByToWikiPageId.
	 * @var Criteria
	 */
	private $lastWikiPageLinksRelatedByToWikiPageIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this WikiPage has previously
	 * been saved, it will retrieve related WikiPageLinksRelatedByToWikiPageId from storage.
	 * If this WikiPage is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getWikiPageLinksRelatedByToWikiPageId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiPageLinkPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collWikiPageLinksRelatedByToWikiPageId === null) {
			if ($this->isNew()) {
			   $this->collWikiPageLinksRelatedByToWikiPageId = array();
			} else {
	
				$criteria->add(UserWikiPageLinkPeer::TO_WIKI_PAGE_ID, $this->getWikiPageId() );

				$this->collWikiPageLinksRelatedByToWikiPageId = UserWikiPageLinkPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserWikiPageLinkPeer::TO_WIKI_PAGE_ID, $this->getWikiPageId());

				if (!isset($this->lastWikiPageLinksRelatedByToWikiPageIdCriteria) || !$this->lastWikiPageLinksRelatedByToWikiPageIdCriteria->equals($criteria)) {
					$this->collWikiPageLinksRelatedByToWikiPageId = UserWikiPageLinkPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastWikiPageLinksRelatedByToWikiPageIdCriteria = $criteria;

		return $this->collWikiPageLinksRelatedByToWikiPageId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this WikiPage is new, it will return
	 * an empty collection; or if this WikiPage has previously
	 * been saved, it will retrieve related WikiPageLinksRelatedByToWikiPageId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in WikiPage.
	 */
	public function getWikiPageLinksRelatedByToWikiPageIdJoinWikiPageRelatedByFromWikiPageId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiPageLinkPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collWikiPageLinksRelatedByToWikiPageId === null) {
			if ($this->isNew()) {
			   $this->collWikiPageLinksRelatedByToWikiPageId = array();
			} else {
	   
				$criteria->add(UserWikiPageLinkPeer::TO_WIKI_PAGE_ID, $this->getWikiPageId());
				$this->collWikiPageLinksRelatedByToWikiPageId = UserWikiPageLinkPeer::doSelectJoinWikiPageRelatedByFromWikiPageId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserWikiPageLinkPeer::TO_WIKI_PAGE_ID, $this->getWikiPageId());
			if (!isset($this->lastWikiPageLinksRelatedByToWikiPageIdCriteria) || !$this->lastWikiPageLinksRelatedByToWikiPageIdCriteria->equals($criteria)) {
				$this->collWikiPageLinksRelatedByToWikiPageId = UserWikiPageLinkPeer::doSelectJoinWikiPageRelatedByFromWikiPageId($criteria, $con);
			}
		}
		$this->lastWikiPageLinksRelatedByToWikiPageIdCriteria = $criteria;

		return $this->collWikiPageLinksRelatedByToWikiPageId;
	}

	/**
	 * Collection to store aggregation of collWikiVersions	  
	 * @var array
	 */
	protected $collWikiVersions; 

	/**
	 * Temporary storage of collWikiVersions to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initWikiVersions()
	{
		if ($this->collWikiVersions === null) {
			$this->collWikiVersions = array();
		}
	}

	/**
	 * Method called to associate a WikiVersion object to this object
	 * through the WikiVersion foreign key attribute
	 *
	 * @param WikiVersion $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addWikiVersion(WikiVersion $l)
	{
		$this->collWikiVersions[] = $l;
		$l->setWikiPage($this);
	}

	/**
	 * The criteria used to select the current contents of collWikiVersions.
	 * @var Criteria
	 */
	private $lastWikiVersionsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this WikiPage has previously
	 * been saved, it will retrieve related WikiVersions from storage.
	 * If this WikiPage is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getWikiVersions($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collWikiVersions === null) {
			if ($this->isNew()) {
			   $this->collWikiVersions = array();
			} else {
	
				$criteria->add(WikiVersionPeer::WIKI_PAGE_ID, $this->getWikiPageId() );

				$this->collWikiVersions = WikiVersionPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(WikiVersionPeer::WIKI_PAGE_ID, $this->getWikiPageId());

				if (!isset($this->lastWikiVersionsCriteria) || !$this->lastWikiVersionsCriteria->equals($criteria)) {
					$this->collWikiVersions = WikiVersionPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastWikiVersionsCriteria = $criteria;

		return $this->collWikiVersions;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this WikiPage is new, it will return
	 * an empty collection; or if this WikiPage has previously
	 * been saved, it will retrieve related WikiVersions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in WikiPage.
	 */
	public function getWikiVersionsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collWikiVersions === null) {
			if ($this->isNew()) {
			   $this->collWikiVersions = array();
			} else {
	   
				$criteria->add(WikiVersionPeer::WIKI_PAGE_ID, $this->getWikiPageId());
				$this->collWikiVersions = WikiVersionPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(WikiVersionPeer::WIKI_PAGE_ID, $this->getWikiPageId());
			if (!isset($this->lastWikiVersionsCriteria) || !$this->lastWikiVersionsCriteria->equals($criteria)) {
				$this->collWikiVersions = WikiVersionPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastWikiVersionsCriteria = $criteria;

		return $this->collWikiVersions;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this WikiPage is new, it will return
	 * an empty collection; or if this WikiPage has previously
	 * been saved, it will retrieve related WikiVersions from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in WikiPage.
	 */
	public function getWikiVersionsJoinWikiPage($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/userwiki/lib/WikiVersionPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collWikiVersions === null) {
			if ($this->isNew()) {
			   $this->collWikiVersions = array();
			} else {
	   
				$criteria->add(WikiVersionPeer::WIKI_PAGE_ID, $this->getWikiPageId());
				$this->collWikiVersions = WikiVersionPeer::doSelectJoinWikiPage($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(WikiVersionPeer::WIKI_PAGE_ID, $this->getWikiPageId());
			if (!isset($this->lastWikiVersionsCriteria) || !$this->lastWikiVersionsCriteria->equals($criteria)) {
				$this->collWikiVersions = WikiVersionPeer::doSelectJoinWikiPage($criteria, $con);
			}
		}
		$this->lastWikiVersionsCriteria = $criteria;

		return $this->collWikiVersions;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("wiki_page_id", "section", "ref_id", "pagename", "flags", "latest_version", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case UserWikiPagePeer::WIKI_PAGE_ID:
				return $this->getWikiPageId();
				break;
		  
			case UserWikiPagePeer::SECTION:
				return $this->getSection();
				break;
		  
			case UserWikiPagePeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case UserWikiPagePeer::PAGENAME:
				return $this->getPagename();
				break;
		  
			case UserWikiPagePeer::FLAGS:
				return $this->getFlags();
				break;
		  
			case UserWikiPagePeer::LATEST_VERSION:
				return $this->getLatestVersion();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getWikiPageId();
				break;
  
			case 1:
				return $this->getSection();
				break;
  
			case 2:
				return $this->getRefId();
				break;
  
			case 3:
				return $this->getPagename();
				break;
  
			case 4:
				return $this->getFlags();
				break;
  
			case 5:
				return $this->getLatestVersion();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(UserWikiPagePeer::WIKI_PAGE_ID, $arr)) $this->setWikiPageId($arr[UserWikiPagePeer::WIKI_PAGE_ID]);
  
		if (array_key_exists(UserWikiPagePeer::SECTION, $arr)) $this->setSection($arr[UserWikiPagePeer::SECTION]);
  
		if (array_key_exists(UserWikiPagePeer::REF_ID, $arr)) $this->setRefId($arr[UserWikiPagePeer::REF_ID]);
  
		if (array_key_exists(UserWikiPagePeer::PAGENAME, $arr)) $this->setPagename($arr[UserWikiPagePeer::PAGENAME]);
  
		if (array_key_exists(UserWikiPagePeer::FLAGS, $arr)) $this->setFlags($arr[UserWikiPagePeer::FLAGS]);
  
		if (array_key_exists(UserWikiPagePeer::LATEST_VERSION, $arr)) $this->setLatestVersion($arr[UserWikiPagePeer::LATEST_VERSION]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case UserWikiPagePeer::WIKI_PAGE_ID:
				$this->setWikiPageId($value);
				break;
	  
			case UserWikiPagePeer::SECTION:
				$this->setSection($value);
				break;
	  
			case UserWikiPagePeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case UserWikiPagePeer::PAGENAME:
				$this->setPagename($value);
				break;
	  
			case UserWikiPagePeer::FLAGS:
				$this->setFlags($value);
				break;
	  
			case UserWikiPagePeer::LATEST_VERSION:
				$this->setLatestVersion($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setWikiPageId($value);
				break;
  
			case 1:
				$this->setSection($value);
				break;
  
			case 2:
				$this->setRefId($value);
				break;
  
			case 3:
				$this->setPagename($value);
				break;
  
			case 4:
				$this->setFlags($value);
				break;
  
			case 5:
				$this->setLatestVersion($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserWikiPagePeer::DATABASE_NAME);

		try {
			$con->begin();
			UserWikiPagePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(UserWikiPagePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UserWikiPagePeer::doInsert($this, $con);
					$this->setWikiPageId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					UserWikiPagePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collWikiPageLinksRelatedByFromWikiPageId !== null) {
				for ($i=0,$size=count($this->collWikiPageLinksRelatedByFromWikiPageId); $i < $size; $i++) {
					$this->collWikiPageLinksRelatedByFromWikiPageId[$i]->save($con);
				}
			  }
			if ($this->collWikiPageLinksRelatedByToWikiPageId !== null) {
				for ($i=0,$size=count($this->collWikiPageLinksRelatedByToWikiPageId); $i < $size; $i++) {
					$this->collWikiPageLinksRelatedByToWikiPageId[$i]->save($con);
				}
			  }
			if ($this->collWikiVersions !== null) {
				for ($i=0,$size=count($this->collWikiVersions); $i < $size; $i++) {
					$this->collWikiVersions[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return UserWikiPagePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = UserWikiPagePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collWikiPageLinksRelatedByFromWikiPageId !== null) {
				for ($i=0,$size=count($this->collWikiPageLinksRelatedByFromWikiPageId); $i < $size; $i++) {
					if (($retval = $this->collWikiPageLinksRelatedByFromWikiPageId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collWikiPageLinksRelatedByToWikiPageId !== null) {
				for ($i=0,$size=count($this->collWikiPageLinksRelatedByToWikiPageId); $i < $size; $i++) {
					if (($retval = $this->collWikiPageLinksRelatedByToWikiPageId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collWikiVersions !== null) {
				for ($i=0,$size=count($this->collWikiVersions); $i < $size; $i++) {
					if (($retval = $this->collWikiVersions[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed wiki_page_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setWikiPageId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getWikiPageId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return WikiPage Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new WikiPage();
		$copyObj->setSection($this->section);
		$copyObj->setRefId($this->ref_id);
		$copyObj->setPagename($this->pagename);
		$copyObj->setFlags($this->flags);
		$copyObj->setLatestVersion($this->latest_version);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getWikiPageLinksRelatedByFromWikiPageId() as $relObj) {
				$copyObj->addWikiPageLinkRelatedByFromWikiPageId($relObj->copy());
			}

			foreach($this->getWikiPageLinksRelatedByToWikiPageId() as $relObj) {
				$copyObj->addWikiPageLinkRelatedByToWikiPageId($relObj->copy());
			}

			foreach($this->getWikiVersions() as $relObj) {
				$copyObj->addWikiVersion($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setWikiPageId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return UserWikiPagePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UserWikiPagePeer();
		}
		return self::$peer;
	}

}
