<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Ruben Gutierrez	ruben@gforgegroup.com
 * @date 2006-03-16
 *
 * SOAP plugin for GForge5.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */


//
// ArtifactQuery
//
$server->wsdl->addComplexType(
	'ArtifactQuery',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'artifact_query_id' => array('name' => 'artifact_query_id', 'type' => 'xsd:int'),
		'name' => array('name' => 'query_name', 'type' => 'xsd:string'),
		'fields' => array('fields' => 'query_name', 'type' => 'tns:ArtifactQueryFields')
	)
);

//
// ArrayOfArtifactQuery
//
$server->wsdl->addComplexType(
	'ArrayOfArtifactQuery',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:ArtifactQuery[]')
	),
	'tns:ArtifactQuery'
);

//
// ArtifactQueryFields
//
$server->wsdl->addComplexType(
	'ArtifactQueryFields',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'sortcol' => array('name' => 'sortcol', 'type' => 'xsd:string'),
		'sortord' => array('name' => 'sortord', 'type' => 'xsd:string'),
		'moddaterange' => array('name' => 'changed', 'type' => 'xsd:string'),
		'assignee' => array('name' => 'assignee', 'type' => 'tns:ArrayOfInteger'),
		'priority' => array('name' => 'priority', 'type' => 'tns:ArrayOfint'),
		'extra_fields' => array('name' => 'extra_fields', 'type' => 'tns:ArrayOfArtifactQueryExtraField'),
		'opendaterange' => array('name' => 'changed', 'type' => 'xsd:string'),
		'closedaterange' => array('name' => 'changed', 'type' => 'xsd:string')
	)
);

//
// ArtifactQueryExtraField
//
$server->wsdl->addComplexType(
	'ArtifactQueryExtraField',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'extra_field_id' => array('name' => 'extra_field_id', 'type' => 'xsd:int'),
		'values' => array('name' => 'values', 'type' => 'tns:ArrayOfint')
	)
);

//
// ArrayOfArtifactQueryExtraField
//
$server->wsdl->addComplexType(
	'ArrayOfArtifactQueryExtraField',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'tns:ArtifactQueryExtraField[]')
	),
	'tns:ArtifactQueryExtraField'
);

//
// ArrayOfUserID
//
$server->wsdl->addComplexType(
	'ArrayOfUserID',
	'complexType',
	'array',
	'',
	'SOAP-ENC:Array',
	array(),
	array(
		array('ref'=>'SOAP-ENC:arrayType','wsdl:arrayType'=>'xsd:int[]')
	),
	'xsd:int'
); 

?>
