<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a ScmCommitFilter and saves it to the 
// database
//
require_once('plugins/scm/lib/ScmCommitFilter.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$ScmCommitFilter = ScmCommitFilterPeer::retrieveByPk($_POST['id']);
if (!is_object($ScmCommitFilter) || !$ScmCommitFilter->userCanUpdate()) {
	throw new PermissionDeniedException();
}

$Lang = Language::getSessLang();

$errors = array();

try {
	$ScmCommitFilter->setFilterDescription( Validator::sanitizeString($_POST['filter_description']) );
	$ScmCommitFilter->setFilterString( Validator::sanitizeString($_POST['filter_string']) );

	$ScmCommitFilter->save();
	GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('ScmCommitFilterBrowse'), array('feedback' => $Lang->getText('ScmCommitFilter.AddFeedback')));
} catch (InvalidDataException $ex) {
	$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
	$feedback = '* '.implode('<br>* ', $errors);
	include('ScmCommitFilterEdit.php');
}

?>