<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing Role
//
require_once('core/RolePeer.php');
require_once('core/Role.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('html/HTMLWidget.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('html/templates/ProjectAdminTemplate.php');
$theme = new ProjectAdminTemplate();

$project = GFUrl::getUrl()->getProject();

$role_id = $_REQUEST['role_id'];
$role = RolePeer::retrieveByPk($role_id);
if (is_null($role) || $role->getProjectId() != $project->getProjectId()) {
	throw new PermissionDeniedException();	
}

$params = array(
		'project' => $project,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('Role.EditPageTitle'),
		'selectedbottomtab'	=> 'project_admin',
		);

$role_name = ( (isset($_POST) && isset($_POST['role_name'])) ? htmlspecialchars($_POST['role_name']) : $role->getRoleName() );

include ('forms/RoleEdit-tpl.php');
?>
